package com.ruoyi.dashboard.index.domain.dto;

import com.ruoyi.ss.refund.domain.RefundQuery;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.springframework.format.annotation.DateTimeFormat;

import java.time.LocalDate;
import java.util.List;

/**
 * @author wjh
 * 2024/10/8
 */
@Data
public class BusinessStatisticsQuery {

    @ApiModelProperty("日期范围")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private List<LocalDate> dateRange;

    @ApiModelProperty("商户ID")
    private Long mchId;

    @ApiModelProperty("合伙人ID")
    private Long staffId;

    @ApiModelProperty("店铺ID")
    private Long storeId;

    @ApiModelProperty("订单状态")
    private List<String> billStatusList;

    @ApiModelProperty("订单类型")
    private String billType;

    @ApiModelProperty("店铺名称")
    private String storeName;

    public RefundQuery toRefundQuery() {
        RefundQuery query = new RefundQuery();
        if (dateRange != null && dateRange.size() >= 2) {
            query.setCreateDateStart(dateRange.get(0));
            query.setCreateDateEnd(dateRange.get(1));
        }
        query.setStoreId(storeId);
        query.setMchId(mchId);
        query.setStoreName(storeName);
        return query;
    }

}
