package com.ruoyi.ss.bonus.domain;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author wjh
 * 2024/8/20
 */
@Data
public class BonusQuery extends BonusVO {

    @ApiModelProperty("订单ID列表")
    private List<Long> billIds;

    @ApiModelProperty("分成方ID列表")
    private List<Long> arrivalIds;

    @ApiModelProperty("分成方类型列表")
    private List<String> arrivalTypes;

    @ApiModelProperty("支付时间：年")
    private Integer payTimeYear;

    @ApiModelProperty("支付日期（起始）")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate payDateStart;

    @ApiModelProperty("支付日期（结束）")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate payDateEnd;

    @ApiModelProperty("支付日期")
    private LocalDate payDate;

    @ApiModelProperty("实际支付时间（起始）")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime payTimeStart;

    @ApiModelProperty("实际支付时间（结束）")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime payTimeEnd;

    @ApiModelProperty("预计支付时间（起始）")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime prePayTimeStart;

    @ApiModelProperty("预计支付时间（结束）")
    @DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    private LocalDateTime prePayTimeEnd;

    @ApiModelProperty("是否有退款")
    private Boolean hasRefund;

    @ApiModelProperty("状态列表")
    private List<String> statusList;

    @ApiModelProperty("创建日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDate;

    @ApiModelProperty("创建日期范围")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private List<LocalDate> createDateRange;
}

