package com.ruoyi.ss.bonus.service;

import java.util.List;

import com.ruoyi.common.core.domain.entity.SysDept;
import com.ruoyi.ss.bonus.domain.Bonus;
import com.ruoyi.ss.channel.domain.Channel;
import com.ruoyi.ss.channel.domain.ChannelVO;
import com.ruoyi.ss.device.domain.vo.DeviceVO;
import com.ruoyi.ss.store.domain.StoreVo;
import com.ruoyi.ss.storeStaff.domain.StoreStaffVO;
import com.ruoyi.ss.transactionBill.domain.vo.TransactionBillVO;
import com.ruoyi.ss.vipOrder.domain.VipOrderVO;

/**
 * @author wjh
 * 2024/8/20
 */
public interface BonusConverter {
    /**
     * 生成设备分成列表
     */
    List<Bonus> toPoList(SysDept platform, DeviceVO device, List<StoreStaffVO> staffList);

    /**
     * 转为分成数据
     */
    List<Bonus> toPoList(VipOrderVO order, Long channelId);

    /**
     * 生成店铺分成列表
     */
    List<Bonus> toPoListByVip(StoreVo store, List<StoreStaffVO> staffList, boolean isPlatform);

    /**
     * 转为分成数据
     *
     * @param device  设备
     * @param bill    充值订单
     * @param channel 渠道类型
     */
    List<Bonus> toPoList(DeviceVO device, TransactionBillVO bill, ChannelVO channel);
}
