package com.ruoyi.ss.channelWithdraw.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.ss.channelWithdraw.domain.ChannelWithdraw;
import com.ruoyi.ss.channelWithdraw.domain.ChannelWithdrawQuery;
import com.ruoyi.ss.channelWithdraw.domain.ChannelWithdrawVO;
import com.ruoyi.ss.channelWithdraw.domain.vo.ChannelWithdrawNameVO;

/**
 * 提现渠道Mapper接口
 *
 * @author ruoyi
 * @date 2024-08-02
 */
public interface ChannelWithdrawMapper
{
    /**
     * 查询提现渠道
     *
     * @param channelId 提现渠道主键
     * @return 提现渠道
     */
    public ChannelWithdrawVO selectChannelWithdrawByChannelId(Long channelId);

    /**
     * 查询提现渠道列表
     *
     * @param query 提现渠道
     * @return 提现渠道集合
     */
    public List<ChannelWithdrawVO> selectChannelWithdrawList(@Param("query")ChannelWithdrawQuery query);

    /**
     * 新增提现渠道
     *
     * @param channelWithdraw 提现渠道
     * @return 结果
     */
    public int insertChannelWithdraw(ChannelWithdraw channelWithdraw);

    /**
     * 修改提现渠道
     *
     * @param channelWithdraw 提现渠道
     * @return 结果
     */
    public int updateChannelWithdraw(@Param("data") ChannelWithdraw channelWithdraw);

    /**
     * 删除提现渠道
     *
     * @param channelId 提现渠道主键
     * @return 结果
     */
    public int deleteChannelWithdrawByChannelId(Long channelId);

    /**
     * 批量删除提现渠道
     *
     * @param channelIds 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteChannelWithdrawByChannelIds(Long[] channelIds);

    /**
     * 查询全部渠道名称列表
     *
     * @param query 渠道查询条件
     * @return 渠道名称列表
     */
    List<ChannelWithdrawNameVO> selectChannelNameList(@Param("query") ChannelWithdrawQuery query);
}
