package com.ruoyi.ss.hardVersion.domain;

import java.util.List;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 硬件版本对象 ss_hard_version
 *
 * @author ruoyi
 * @date 2025-03-11
 */
@Data
public class HardVersion extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "版本代码")
    @ApiModelProperty("版本代码")
    @NotBlank(message = "版本代码不能为空")
    @Size(max = 64, message = "版本代码长度不能超过64个字符")
    private String code;

    @Excel(name = "适用型号列表")
    @ApiModelProperty("适用型号列表")
    private List<Long> modelIds;

    @Excel(name = "文件链接")
    @ApiModelProperty("文件链接")
    private String fileUrl;

}
