package com.ruoyi.ss.hardVersion.mapper;

import java.util.List;
import com.ruoyi.ss.hardVersion.domain.HardVersion;
import com.ruoyi.ss.hardVersion.domain.HardVersionVO;
import com.ruoyi.ss.hardVersion.domain.HardVersionQuery;
import org.apache.ibatis.annotations.Param;

/**
 * 硬件版本Mapper接口
 *
 * @author ruoyi
 * @date 2025-03-11
 */
public interface HardVersionMapper
{
    /**
     * 查询硬件版本
     *
     * @param id 硬件版本主键
     * @return 硬件版本
     */
    HardVersionVO selectHardVersionById(Long id);

    /**
     * 查询硬件版本列表
     *
     * @param query 硬件版本
     * @return 硬件版本集合
     */
    List<HardVersionVO> selectHardVersionList(@Param("query")HardVersionQuery query);

    /**
     * 新增硬件版本
     *
     * @param hardVersion 硬件版本
     * @return 结果
     */
    int insertHardVersion(HardVersion hardVersion);

    /**
     * 批量新增硬件版本
     */
    int batchInsert(@Param("list") List<? extends HardVersion> list);

    /**
     * 批量修改硬件版本
     */
    int batchUpdate(@Param("list") List<? extends HardVersion> list);

    /**
     * 修改硬件版本
     *
     * @param hardVersion 硬件版本
     * @return 结果
     */
    public int updateHardVersion(@Param("data") HardVersion hardVersion);

    /**
     * 删除硬件版本
     *
     * @param id 硬件版本主键
     * @return 结果
     */
    int deleteHardVersionById(Long id);

    /**
     * 批量删除硬件版本
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteHardVersionByIds(Long[] ids);
}
