package com.ruoyi.ss.hardVersion.service;

import java.util.List;

import com.ruoyi.ss.hardVersion.domain.HardVersion;
import com.ruoyi.ss.hardVersion.domain.HardVersionQuery;
import com.ruoyi.ss.hardVersion.domain.HardVersionVO;

/**
 * 硬件版本Service接口
 *
 * @author ruoyi
 * @date 2025-03-11
 */
public interface HardVersionService
{
    /**
     * 查询硬件版本
     *
     * @param id 硬件版本主键
     * @return 硬件版本
     */
    public HardVersionVO selectHardVersionById(Long id);

    /**
     * 查询硬件版本列表
     *
     * @param hardVersion 硬件版本
     * @return 硬件版本集合
     */
    public List<HardVersionVO> selectHardVersionList(HardVersionQuery hardVersion);

    /**
     * 新增硬件版本
     *
     * @param hardVersion 硬件版本
     * @return 结果
     */
    public int insertHardVersion(HardVersion hardVersion);

    /**
     * 修改硬件版本
     *
     * @param hardVersion 硬件版本
     * @return 结果
     */
    public int updateHardVersion(HardVersion hardVersion);

    /**
     * 批量删除硬件版本
     *
     * @param ids 需要删除的硬件版本主键集合
     * @return 结果
     */
    public int deleteHardVersionByIds(Long[] ids);

    /**
     * 删除硬件版本信息
     *
     * @param id 硬件版本主键
     * @return 结果
     */
    public int deleteHardVersionById(Long id);

    /**
     * 查询一个
     *
     * @param query 查询条件
     * @return 硬件版本
     */
    public HardVersionVO selectOne(HardVersionQuery query);
}
