package com.ruoyi.ss.hardVersion.service.impl;

import java.util.Collection;
import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ruoyi.common.utils.collection.CollectionUtils;
import com.ruoyi.ss.hardVersion.domain.HardVersion;
import com.ruoyi.ss.hardVersion.domain.HardVersionVO;
import com.ruoyi.ss.hardVersion.service.HardVersionAssembler;
import com.ruoyi.ss.model.domain.SmModelVO;
import com.ruoyi.ss.model.service.ModelService;

@Service
public class HardVersionAssemblerImpl implements HardVersionAssembler {
    
    @Autowired
    private ModelService modelService;

    @Override
    public void assembleModelList(List<HardVersionVO> list) {
        if (CollectionUtils.isEmptyElement(list)) {
            return;
        }

        List<Long> modelIds = list.stream().map(HardVersion::getModelIds).flatMap(Collection::stream).distinct().collect(Collectors.toList());
        List<SmModelVO> modelList = modelService.selectSmModelListByIds(modelIds);

        for (HardVersionVO hardVersion : list) {
            List<SmModelVO> versionModelList = modelList.stream()
                .filter(model -> hardVersion.getModelIds().contains(model.getModelId()))
                .collect(Collectors.toList());
            hardVersion.setModelList(versionModelList);
        }
    }
    
}
