package com.ruoyi.ss.help.domain;


import javax.validation.constraints.NotBlank;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import com.ruoyi.common.core.domain.ValidGroup;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 教程对象 ss_help
 *
 * @author ruoyi
 * @date 2025-02-26
 */
@Data
public class Help extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "标题")
    @ApiModelProperty("标题")
    @NotBlank(message = "标题不能为空", groups = {ValidGroup.Create.class})
    private String title;

    @Excel(name = "状态", readConverterExp = "1=启用,2=禁用")
    @ApiModelProperty("状态")
    @NotBlank(message = "状态不能为空", groups = {ValidGroup.Create.class})
    private String status;

    @Excel(name = "视频url")
    @ApiModelProperty("视频url")
    @NotBlank(message = "视频url不能为空", groups = {ValidGroup.Create.class})
    private String videoUrl;

    @Excel(name = "封面url")
    @ApiModelProperty("封面url")
    private String coverUrl;

    @Excel(name = "编码")
    @ApiModelProperty("编码")
    private String code;

}
