package com.ruoyi.ss.help.mapper;

import java.util.List;
import com.ruoyi.ss.help.domain.Help;
import com.ruoyi.ss.help.domain.HelpVO;
import com.ruoyi.ss.help.domain.HelpQuery;
import org.apache.ibatis.annotations.Param;

/**
 * 教程Mapper接口
 *
 * @author ruoyi
 * @date 2025-02-26
 */
public interface HelpMapper
{
    /**
     * 查询教程
     *
     * @param id 教程主键
     * @return 教程
     */
    HelpVO selectHelpById(Long id);

    /**
     * 查询教程列表
     *
     * @param query 教程
     * @return 教程集合
     */
    List<HelpVO> selectHelpList(@Param("query")HelpQuery query);

    /**
     * 新增教程
     *
     * @param help 教程
     * @return 结果
     */
    int insertHelp(Help help);

    /**
     * 批量新增教程
     */
    int batchInsert(@Param("list") List<? extends Help> list);

    /**
     * 批量修改教程
     */
    int batchUpdate(@Param("list") List<? extends Help> list);

    /**
     * 修改教程
     *
     * @param help 教程
     * @return 结果
     */
    public int updateHelp(@Param("data") Help help);

    /**
     * 删除教程
     *
     * @param id 教程主键
     * @return 结果
     */
    int deleteHelpById(Long id);

    /**
     * 批量删除教程
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteHelpByIds(Long[] ids);
}
