package com.ruoyi.ss.help.service;

import java.util.List;

import com.ruoyi.ss.help.domain.Help;
import com.ruoyi.ss.help.domain.HelpQuery;
import com.ruoyi.ss.help.domain.HelpVO;

/**
 * 教程Service接口
 *
 * @author ruoyi
 * @date 2025-02-26
 */
public interface HelpService
{
    /**
     * 查询教程
     *
     * @param id 教程主键
     * @return 教程
     */
    public HelpVO selectHelpById(Long id);

    /**
     * 查询教程列表
     *
     * @param help 教程
     * @return 教程集合
     */
    public List<HelpVO> selectHelpList(HelpQuery help);

    /**
     * 新增教程
     *
     * @param help 教程
     * @return 结果
     */
    public int insertHelp(Help help);

    /**
     * 修改教程
     *
     * @param help 教程
     * @return 结果
     */
    public int updateHelp(Help help);

    /**
     * 批量删除教程
     *
     * @param ids 需要删除的教程主键集合
     * @return 结果
     */
    public int deleteHelpByIds(Long[] ids);

    /**
     * 删除教程信息
     *
     * @param id 教程主键
     * @return 结果
     */
    public int deleteHelpById(Long id);

    /**
     * 通过教程编码获取教程详情
     *
     * @param code 教程编码
     * @return 教程详情
     */
    public HelpVO selectByCode(String code);
}
