package com.ruoyi.ss.reconciliationDate.domain;

import java.math.BigDecimal;
import java.time.LocalDate;

import org.springframework.format.annotation.DateTimeFormat;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 日期对账对象 ss_reconciliation_date
 *
 * @author ruoyi
 * @date 2025-01-25
 */
@Data
public class ReconciliationDate extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @DateTimeFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "日期", width = 30, dateFormat = "yyyy-MM-dd")
    @ApiModelProperty("日期")
    private LocalDate date;

    @Excel(name = "充值订单金额")
    @ApiModelProperty("充值订单金额")
    private BigDecimal orderAmount;

    @Excel(name = "VIP订单金额")
    @ApiModelProperty("VIP订单金额")
    private BigDecimal vipOrderAmount;

    @Excel(name = "退款金额")
    @ApiModelProperty("退款金额")
    private BigDecimal refundAmount;

    @Excel(name = "用户分成")
    @ApiModelProperty("用户分成")
    private BigDecimal userBonus;

    @Excel(name = "平台分成")
    @ApiModelProperty("平台分成")
    private BigDecimal platformBonus;

    @Excel(name = "提现金额")
    @ApiModelProperty("提现金额")
    private BigDecimal withdrawAmount;

    @Excel(name = "应收账金额")
    @ApiModelProperty("应收账金额")
    private BigDecimal receiveAmount;

    @Excel(name = "用户分成退款")
    @ApiModelProperty("用户分成退款")
    private BigDecimal userBonusRefund;

    @Excel(name = "平台分成退款")
    @ApiModelProperty("平台分成退款")
    private BigDecimal platformBonusRefund;

    @Excel(name = "分成总退款")
    @ApiModelProperty("分成总退款")
    private BigDecimal totalBonusRefund;

    @Excel(name = "实际分成")
    @ApiModelProperty("实际分成")
    private BigDecimal actualBonus;

    @Excel(name = "订单总额")
    @ApiModelProperty("订单总额")
    private BigDecimal orderTotalAmount;

    @Excel(name = "订单实收金额")
    @ApiModelProperty("订单实收金额")
    private BigDecimal orderReceiveAmount;

    @Excel(name = "总分成")
    @ApiModelProperty("总分成")
    private BigDecimal totalBonus;

    @Excel(name = "实收和分成差额")
    @ApiModelProperty("实收和分成差额")
    private BigDecimal difference;

    @Excel(name = "平台收益")
    @ApiModelProperty("平台收益")
    private BigDecimal platformIncome;

    @Excel(name = "提现服务费")
    @ApiModelProperty("提现服务费")
    private BigDecimal withdrawServiceFee;

    @Excel(name = "渠道成本")
    @ApiModelProperty("渠道成本")
    private BigDecimal channelCost;

    @Excel(name = "渠道类型")
    @ApiModelProperty("渠道类型")
    private Integer channelType;

    @Excel(name = "渠道ID")
    @ApiModelProperty("渠道ID")
    private Long channelId;

    @Excel(name = "渠道名称")
    @ApiModelProperty("渠道名称")
    private String channelName;

    @ApiModelProperty("用户实收金额")
    private BigDecimal userActualBonus;

    @ApiModelProperty("平台实收金额")
    private BigDecimal platformActualBonus;

}
