package com.ruoyi.ss.reconciliationDate.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDate;
import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDateQuery;
import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDateVO;

/**
 * 日期对账Mapper接口
 *
 * @author ruoyi
 * @date 2025-01-25
 */
public interface ReconciliationDateMapper
{
    /**
     * 查询日期对账
     *
     * @param id 日期对账主键
     * @return 日期对账
     */
    ReconciliationDateVO selectReconciliationDateById(Long id);

    /**
     * 查询日期对账列表
     *
     * @param query 日期对账
     * @return 日期对账集合
     */
    List<ReconciliationDateVO> selectReconciliationDateList(@Param("query")ReconciliationDateQuery query);

    /**
     * 新增日期对账
     *
     * @param reconciliationDate 日期对账
     * @return 结果
     */
    int insertReconciliationDate(ReconciliationDate reconciliationDate);

    /**
     * 修改日期对账
     *
     * @param reconciliationDate 日期对账
     * @return 结果
     */
    public int updateReconciliationDate(@Param("data") ReconciliationDate reconciliationDate);

    /**
     * 删除日期对账
     *
     * @param id 日期对账主键
     * @return 结果
     */
    int deleteReconciliationDateById(Long id);

    /**
     * 批量删除日期对账
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteReconciliationDateByIds(Long[] ids);

    /**
     * 根据查询日期对账列表并分组
     *
     * @param query 查询条件
     * @param groupBy 分组字段
     * @return 日期对账列表
     */
    List<ReconciliationDateVO> selectReconciliationDateListGroupBy(@Param("query") ReconciliationDateQuery query, @Param("groupBy") String groupBy);
}
