package com.ruoyi.ss.reconciliationDate.service;

import java.util.List;

import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDate;
import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDateQuery;
import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDateVO;

/**
 * 日期对账Service接口
 *
 * @author ruoyi
 * @date 2025-01-25
 */
public interface ReconciliationDateService
{
    /**
     * 查询日期对账
     *
     * @param id 日期对账主键
     * @return 日期对账
     */
    public ReconciliationDateVO selectReconciliationDateById(Long id);

    /**
     * 查询日期对账列表
     *
     * @param reconciliationDate 日期对账
     * @return 日期对账集合
     */
    public List<ReconciliationDateVO> selectReconciliationDateList(ReconciliationDateQuery reconciliationDate);

    /**
     * 新增日期对账
     *
     * @param reconciliationDate 日期对账
     * @return 结果
     */
    public int insertReconciliationDate(ReconciliationDate reconciliationDate);

    /**
     * 修改日期对账
     *
     * @param reconciliationDate 日期对账
     * @return 结果
     */
    public int updateReconciliationDate(ReconciliationDate reconciliationDate);

    /**
     * 批量删除日期对账
     *
     * @param ids 需要删除的日期对账主键集合
     * @return 结果
     */
    public int deleteReconciliationDateByIds(Long[] ids);

    /**
     * 删除日期对账信息
     *
     * @param id 日期对账主键
     * @return 结果
     */
    public int deleteReconciliationDateById(Long id);

    /**
     * 根据查询日期对账列表并分组
     *
     * @param query 查询条件
     * @param groupBy 分组字段
     * @return 日期对账列表
     */
    List<ReconciliationDateVO> selectReconciliationDateListGroupBy(ReconciliationDateQuery query, String groupBy);
}
