package com.ruoyi.ss.reconciliationDate.service.impl;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDate;
import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDateQuery;
import com.ruoyi.ss.reconciliationDate.domain.ReconciliationDateVO;
import com.ruoyi.ss.reconciliationDate.mapper.ReconciliationDateMapper;
import com.ruoyi.ss.reconciliationDate.service.ReconciliationDateService;

/**
 * 日期对账Service业务层处理
 *
 * @author ruoyi
 * @date 2025-01-25
 */
@Service
public class ReconciliationDateServiceImpl implements ReconciliationDateService
{
    @Autowired
    private ReconciliationDateMapper reconciliationDateMapper;

    /**
     * 查询日期对账
     *
     * @param id 日期对账主键
     * @return 日期对账
     */
    @Override
    public ReconciliationDateVO selectReconciliationDateById(Long id)
    {
        return reconciliationDateMapper.selectReconciliationDateById(id);
    }

    /**
     * 查询日期对账列表
     *
     * @param reconciliationDate 日期对账
     * @return 日期对账
     */
    @Override
    public List<ReconciliationDateVO> selectReconciliationDateList(ReconciliationDateQuery reconciliationDate)
    {
        return reconciliationDateMapper.selectReconciliationDateList(reconciliationDate);
    }

    /**
     * 新增日期对账
     *
     * @param reconciliationDate 日期对账
     * @return 结果
     */
    @Override
    public int insertReconciliationDate(ReconciliationDate reconciliationDate)
    {
        return reconciliationDateMapper.insertReconciliationDate(reconciliationDate);
    }

    /**
     * 修改日期对账
     *
     * @param reconciliationDate 日期对账
     * @return 结果
     */
    @Override
    public int updateReconciliationDate(ReconciliationDate reconciliationDate)
    {
        return reconciliationDateMapper.updateReconciliationDate(reconciliationDate);
    }

    /**
     * 批量删除日期对账
     *
     * @param ids 需要删除的日期对账主键
     * @return 结果
     */
    @Override
    public int deleteReconciliationDateByIds(Long[] ids)
    {
        return reconciliationDateMapper.deleteReconciliationDateByIds(ids);
    }

    /**
     * 删除日期对账信息
     *
     * @param id 日期对账主键
     * @return 结果
     */
    @Override
    public int deleteReconciliationDateById(Long id)
    {
        return reconciliationDateMapper.deleteReconciliationDateById(id);
    }

    @Override
    public List<ReconciliationDateVO> selectReconciliationDateListGroupBy(ReconciliationDateQuery query, String groupBy) {
        return reconciliationDateMapper.selectReconciliationDateListGroupBy(query, groupBy);
    }
}
