package com.ruoyi.ss.refund.domain;

import java.time.LocalDate;
import java.util.List;

import org.springframework.format.annotation.DateTimeFormat;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author wjh
 *         2024/7/9
 */
@Data
public class RefundQuery extends RefundVO {

    @ApiModelProperty("订单收款人ID")
    private Long billMchId;

    @ApiModelProperty("创建日期（起始）")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDateStart;

    @ApiModelProperty("创建日期（结束）")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDateEnd;

    @ApiModelProperty("状态列表")
    private List<String> statusList;

    @ApiModelProperty("创建日期")
    @DateTimeFormat(pattern = "yyyy-MM-dd")
    private LocalDate createDate;

    @ApiModelProperty("店铺ID列表")
    private List<Long> storeIds;

    @ApiModelProperty("月份")
    private Integer month;

    @ApiModelProperty("年份")
    private Integer year;

    @ApiModelProperty("商户ID")
    private Long mchId;

    @ApiModelProperty("店铺名称")
    private String storeName;

}
