package com.ruoyi.ss.risk.domain;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.Date;
import java.util.List;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.ruoyi.common.core.domain.ValidGroup;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;

/**
 * 风控对象 ss_risk
 *
 * @author ruoyi
 * @date 2024-10-18
 */
@Data
public class Risk extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long riskId;

    @Excel(name = "用户ID")
    @ApiModelProperty("用户ID")
    @NotNull(message = "用户不允许为空", groups = {ValidGroup.Create.class})
    private Long userId;

    @Excel(name = "类型")
    @ApiModelProperty("类型")
    @NotNull(message = "类型不允许为空", groups = {ValidGroup.Create.class})
    private List<String> type;

    @Excel(name = "风控原因")
    @ApiModelProperty("风控原因")
    private String reason;

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss")
    @Excel(name = "结束时间", width = 30, dateFormat = "yyyy-MM-dd HH:mm:ss")
    @ApiModelProperty("结束时间")
    private LocalDateTime endTime;

    @Excel(name = "是否允许自行解封")
    @ApiModelProperty("是否允许自行解封")
    private Boolean unsealSelf;

    @Excel(name = "需要提交的材料类型列表")
    @ApiModelProperty("需要提交的材料类型列表")
    private List<String> submitType;

    @Excel(name = "视频自定义词汇")
    @ApiModelProperty("视频自定义词汇")
    private String videoWords;
}
