package com.ruoyi.ss.snLog.mapper;

import java.util.List;
import com.ruoyi.ss.snLog.domain.SnLog;
import com.ruoyi.ss.snLog.domain.SnLogVO;
import com.ruoyi.ss.snLog.domain.SnLogQuery;
import org.apache.ibatis.annotations.Param;

/**
 * Sn码更换日志Mapper接口
 *
 * @author ruoyi
 * @date 2025-03-31
 */
public interface SnLogMapper
{
    /**
     * 查询Sn码更换日志
     *
     * @param id Sn码更换日志主键
     * @return Sn码更换日志
     */
    SnLogVO selectSnLogById(Long id);

    /**
     * 查询Sn码更换日志列表
     *
     * @param query Sn码更换日志
     * @return Sn码更换日志集合
     */
    List<SnLogVO> selectSnLogList(@Param("query")SnLogQuery query);

    /**
     * 新增Sn码更换日志
     *
     * @param snLog Sn码更换日志
     * @return 结果
     */
    int insertSnLog(SnLog snLog);

    /**
     * 批量新增Sn码更换日志
     */
    int batchInsert(@Param("list") List<? extends SnLog> list);

    /**
     * 批量修改Sn码更换日志
     */
    int batchUpdate(@Param("list") List<? extends SnLog> list);

    /**
     * 修改Sn码更换日志
     *
     * @param snLog Sn码更换日志
     * @return 结果
     */
    public int updateSnLog(@Param("data") SnLog snLog);

    /**
     * 删除Sn码更换日志
     *
     * @param id Sn码更换日志主键
     * @return 结果
     */
    int deleteSnLogById(Long id);

    /**
     * 批量删除Sn码更换日志
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSnLogByIds(Long[] ids);
}
