package com.ruoyi.ss.snLog.service;

import java.util.List;
import com.ruoyi.ss.snLog.domain.SnLog;
import com.ruoyi.ss.snLog.domain.SnLogVO;
import com.ruoyi.ss.snLog.domain.SnLogQuery;

/**
 * Sn码更换日志Service接口
 *
 * @author ruoyi
 * @date 2025-03-31
 */
public interface SnLogService
{
    /**
     * 查询Sn码更换日志
     *
     * @param id Sn码更换日志主键
     * @return Sn码更换日志
     */
    public SnLogVO selectSnLogById(Long id);

    /**
     * 查询Sn码更换日志列表
     *
     * @param snLog Sn码更换日志
     * @return Sn码更换日志集合
     */
    public List<SnLogVO> selectSnLogList(SnLogQuery snLog);

    /**
     * 新增Sn码更换日志
     *
     * @param snLog Sn码更换日志
     * @return 结果
     */
    public int insertSnLog(SnLog snLog);

    /**
     * 修改Sn码更换日志
     *
     * @param snLog Sn码更换日志
     * @return 结果
     */
    public int updateSnLog(SnLog snLog);

    /**
     * 批量删除Sn码更换日志
     *
     * @param ids 需要删除的Sn码更换日志主键集合
     * @return 结果
     */
    public int deleteSnLogByIds(Long[] ids);

    /**
     * 删除Sn码更换日志信息
     *
     * @param id Sn码更换日志主键
     * @return 结果
     */
    public int deleteSnLogById(Long id);
}
