package com.ruoyi.ss.snLog.service.impl;

import java.util.List;
import com.ruoyi.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.ss.snLog.mapper.SnLogMapper;
import com.ruoyi.ss.snLog.domain.SnLog;
import com.ruoyi.ss.snLog.domain.SnLogVO;
import com.ruoyi.ss.snLog.domain.SnLogQuery;
import com.ruoyi.ss.snLog.service.SnLogService;

/**
 * Sn码更换日志Service业务层处理
 *
 * @author ruoyi
 * @date 2025-03-31
 */
@Service
public class SnLogServiceImpl implements SnLogService
{
    @Autowired
    private SnLogMapper snLogMapper;

    /**
     * 查询Sn码更换日志
     *
     * @param id Sn码更换日志主键
     * @return Sn码更换日志
     */
    @Override
    public SnLogVO selectSnLogById(Long id)
    {
        return snLogMapper.selectSnLogById(id);
    }

    /**
     * 查询Sn码更换日志列表
     *
     * @param snLog Sn码更换日志
     * @return Sn码更换日志
     */
    @Override
    public List<SnLogVO> selectSnLogList(SnLogQuery snLog)
    {
        return snLogMapper.selectSnLogList(snLog);
    }

    /**
     * 新增Sn码更换日志
     *
     * @param snLog Sn码更换日志
     * @return 结果
     */
    @Override
    public int insertSnLog(SnLog snLog)
    {
        return snLogMapper.insertSnLog(snLog);
    }

    /**
     * 修改Sn码更换日志
     *
     * @param snLog Sn码更换日志
     * @return 结果
     */
    @Override
    public int updateSnLog(SnLog snLog)
    {
        snLog.setUpdateTime(DateUtils.getNowDate());
        return snLogMapper.updateSnLog(snLog);
    }

    /**
     * 批量删除Sn码更换日志
     *
     * @param ids 需要删除的Sn码更换日志主键
     * @return 结果
     */
    @Override
    public int deleteSnLogByIds(Long[] ids)
    {
        return snLogMapper.deleteSnLogByIds(ids);
    }

    /**
     * 删除Sn码更换日志信息
     *
     * @param id Sn码更换日志主键
     * @return 结果
     */
    @Override
    public int deleteSnLogById(Long id)
    {
        return snLogMapper.deleteSnLogById(id);
    }
}
