package com.ruoyi.ss.store.domain;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

import com.fasterxml.jackson.annotation.JsonView;
import com.ruoyi.common.core.domain.JsonViewProfile;
import com.ruoyi.ss.bonus.domain.Bonus;
import com.ruoyi.ss.device.domain.enums.DeviceStatus;
import com.ruoyi.ss.store.domain.vo.StoreOperatorVO;
import com.ruoyi.ss.storeApply.domain.StoreApplyVO;
import com.ruoyi.ss.storeStaff.domain.StoreStaffVO;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * @author 辉
 * 2024/3/5
 */
@EqualsAndHashCode(callSuper = true)
@Data
public class StoreVo extends Store {

    @ApiModelProperty("该店铺下的设备数量")
    @JsonView({StoreView.ListCount.class, JsonViewProfile.App.class})
    private Integer deviceCount;

    @ApiModelProperty("绑定用户名称")
    private String userName;

    @ApiModelProperty("本日收入")
    private BigDecimal todayIncome;

    @ApiModelProperty("总收入")
    private BigDecimal totalIncome;

    @ApiModelProperty("本日订单数量")
    private Integer todayOrderCount;

    @ApiModelProperty("总订单数量")
    private Integer totalOrderCount;

    @ApiModelProperty("本月收入")
    private BigDecimal monthIncome;

    @ApiModelProperty("上月收入")
    private BigDecimal lastMonthIncome;

    @ApiModelProperty("在线设备数量")
    private Integer onlineCount;

    @ApiModelProperty("离线设备数量")
    private Integer offlineCount;

    @ApiModelProperty("可共享的设备数量")
    @JsonView(JsonViewProfile.App.class)
    private Integer availableDeviceCount;

    @ApiModelProperty("操作")
    private StoreOperatorVO operator;

    @ApiModelProperty("商户VIP服务费")
    private BigDecimal mchVipServiceRate;

    @ApiModelProperty("店铺分成")
    private List<Bonus> bonusList;

    @ApiModelProperty("店铺员工")
    private List<StoreStaffVO> staffList;

    @ApiModelProperty("最后一次审核记录")
    private StoreApplyVO apply;

    @ApiModelProperty("空闲设备数量")
    private Long normalDeviceCount;

    @ApiModelProperty("使用中设备数量")
    private Long usingDeviceCount;

    @ApiModelProperty("店铺类型名称")
    private String typeName;

    @ApiModelProperty("店铺类型图标")
    private String typeIcon;

    public void setDeviceStatusMap(Map<String, Object> statusMap) {
        if (statusMap == null) {
            return;
        }
        this.normalDeviceCount = (Long) statusMap.get(DeviceStatus.NORMAL.getStatus());
        if (normalDeviceCount == null) {
            this.normalDeviceCount = 0L;
        }
        this.usingDeviceCount = (Long) statusMap.get(DeviceStatus.USING.getStatus());
        if (usingDeviceCount == null) {
            this.usingDeviceCount = 0L;
        }
    }
}
