package com.ruoyi.ss.store.domain.enums;

import java.util.List;

import com.ruoyi.common.utils.collection.CollectionUtils;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * 店铺状态
 * @author wjh
 * 2024/8/3
 */
@Getter
@AllArgsConstructor
public enum StoreStatus {

    WAIT_SUBMIT("3", "待审核"),
    APPROVING("2", "审核中"),
    PASS("1", "审核通过"),
    REJECT("4", "审核不通过");

    private final String status;
    private final String name;

    // 允许设置展示的店铺状态
    public static List<String> canSetShow() {
        return CollectionUtils.map(StoreStatus::getStatus, WAIT_SUBMIT, REJECT);
    }
        
    // 允许设置隐藏的店铺状态
    public static List<String> canSetHide() {
        return CollectionUtils.map(StoreStatus::getStatus, APPROVING, PASS, REJECT);
    }

    // 允许审核的店铺状态
    public static List<String> canVerify() {
        return CollectionUtils.map(StoreStatus::getStatus, APPROVING);
    }

    // 允许已读驳回的店铺状态
    public static List<String> canReadReject() {
        return CollectionUtils.map(StoreStatus::getStatus, REJECT);
    }
}
