package com.ruoyi.ss.storeType.domain;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;
import javax.validation.constraints.Size;

import com.ruoyi.common.annotation.Excel;
import com.ruoyi.common.core.domain.BaseEntity;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * 店铺类型对象 ss_store_type
 *
 * @author ruoyi
 * @date 2025-02-27
 */
@Data
public class StoreType extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    private Long id;

    @Excel(name = "名称")
    @ApiModelProperty("名称")
    @NotBlank(message = "名称不能为空")
    @Size(max = 30, message = "名称长度不能超过30个字符")
    private String name;

    @Excel(name = "图标")
    @ApiModelProperty("图标")
    private String icon;

    @ApiModelProperty("排序")
    @NotNull(message = "排序不能为空")
    private Integer sort;

    @Excel(name = "上级ID")
    @ApiModelProperty("上级ID") 
    private Long parentId;
}
