package com.ruoyi.ss.storeType.mapper;

import java.util.List;

import org.apache.ibatis.annotations.Param;

import com.ruoyi.ss.store.domain.StoreNameVO;
import com.ruoyi.ss.storeType.domain.StoreType;
import com.ruoyi.ss.storeType.domain.StoreTypeQuery;
import com.ruoyi.ss.storeType.domain.StoreTypeVO;

/**
 * 店铺类型Mapper接口
 *
 * @author ruoyi
 * @date 2025-02-27
 */
public interface StoreTypeMapper
{
    /**
     * 查询店铺类型
     *
     * @param id 店铺类型主键
     * @return 店铺类型
     */
    StoreTypeVO selectStoreTypeById(Long id);

    /**
     * 查询店铺类型列表
     *
     * @param query 店铺类型
     * @return 店铺类型集合
     */
    List<StoreTypeVO> selectStoreTypeList(@Param("query")StoreTypeQuery query);

    /**
     * 新增店铺类型
     *
     * @param storeType 店铺类型
     * @return 结果
     */
    int insertStoreType(StoreType storeType);

    /**
     * 批量新增店铺类型
     */
    int batchInsert(@Param("list") List<? extends StoreType> list);

    /**
     * 批量修改店铺类型
     */
    int batchUpdate(@Param("list") List<? extends StoreType> list);

    /**
     * 修改店铺类型
     *
     * @param storeType 店铺类型
     * @return 结果
     */
    public int updateStoreType(@Param("data") StoreType storeType);

    /**
     * 删除店铺类型
     *
     * @param id 店铺类型主键
     * @return 结果
     */
    int deleteStoreTypeById(Long id);

    /**
     * 批量删除店铺类型
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteStoreTypeByIds(Long[] ids);

    /**
     * 查询全部店铺类型名称
     * @param query
     * @return
     */
    List<StoreNameVO> selectListName(@Param("query")StoreTypeQuery query);
}
