package com.ruoyi.ss.storeType.service;

import java.util.List;

import com.ruoyi.ss.storeType.domain.StoreType;
import com.ruoyi.ss.storeType.domain.StoreTypeQuery;
import com.ruoyi.ss.storeType.domain.StoreTypeVO;

/**
 * 店铺类型Service接口
 *
 * @author ruoyi
 * @date 2025-02-27
 */
public interface StoreTypeService
{
    /**
     * 查询店铺类型
     *
     * @param id 店铺类型主键
     * @return 店铺类型
     */
    public StoreTypeVO selectStoreTypeById(Long id);

    /**
     * 查询店铺类型列表
     *
     * @param storeType 店铺类型
     * @return 店铺类型集合
     */
    public List<StoreTypeVO> selectStoreTypeList(StoreTypeQuery storeType);

    /**
     * 新增店铺类型
     *
     * @param storeType 店铺类型
     * @return 结果
     */
    public int insertStoreType(StoreType storeType);

    /**
     * 修改店铺类型
     *
     * @param storeType 店铺类型
     * @return 结果
     */
    public int updateStoreType(StoreType storeType);

    /**
     * 批量删除店铺类型
     *
     * @param ids 需要删除的店铺类型主键集合
     * @return 结果
     */
    public int deleteStoreTypeByIds(Long[] ids);
    
    /**
     * 查询全部店铺类型名称
     * @return
     */
    public List<StoreTypeVO> selectListAllName();
}
