package com.ruoyi.ss.transactionBill.service.impl;

import java.math.BigDecimal;
import java.math.RoundingMode;
import java.time.Duration;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Objects;
import java.util.concurrent.ScheduledExecutorService;
import java.util.concurrent.TimeUnit;
import java.util.function.Function;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.transaction.support.TransactionTemplate;

import com.alibaba.fastjson2.JSONObject;
import com.github.pagehelper.PageHelper;
import com.ruoyi.common.constant.Constants;
import com.ruoyi.common.core.redis.RedisLock;
import com.ruoyi.common.core.redis.enums.RedisLockKey;
import com.ruoyi.common.domain.vo.LocalDateDecimalVO;
import com.ruoyi.common.domain.vo.LocalDateTimeIntegerVO;
import com.ruoyi.common.domain.vo.LongDecimalVO;
import com.ruoyi.common.domain.vo.LongIntegerVO;
import com.ruoyi.common.enums.ServiceCode;
import com.ruoyi.common.enums.WithdrawServiceType;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.ServiceUtil;
import com.ruoyi.common.utils.SnowFlakeUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.collection.CollectionUtils;
import com.ruoyi.dashboard.index.domain.vo.BillCountVo;
import com.ruoyi.iot.domain.response.CommandResponse;
import com.ruoyi.iot.service.IotService;
import com.ruoyi.ss.account.domain.AccountVO;
import com.ruoyi.ss.billEleRecord.domain.BillEleRecord;
import com.ruoyi.ss.billEleRecord.domain.BillEleRecordQuery;
import com.ruoyi.ss.billEleRecord.service.BillEleRecordConverter;
import com.ruoyi.ss.billEleRecord.service.BillEleRecordService;
import com.ruoyi.ss.bonus.domain.Bonus;
import com.ruoyi.ss.bonus.domain.BonusVO;
import com.ruoyi.ss.bonus.domain.enums.BonusArrivalType;
import com.ruoyi.ss.bonus.domain.enums.BonusStatus;
import com.ruoyi.ss.bonus.service.BonusService;
import com.ruoyi.ss.bonus.utils.BonusUtil;
import com.ruoyi.ss.bonusRefund.domain.BonusRefund;
import com.ruoyi.ss.bonusRefund.service.BonusRefundConverter;
import com.ruoyi.ss.bonusRefund.service.BonusRefundService;
import com.ruoyi.ss.channelWithdraw.domain.ChannelWithdrawVO;
import com.ruoyi.ss.channelWithdraw.service.ChannelWithdrawService;
import com.ruoyi.ss.device.domain.enums.DevicePowerStatus;
import com.ruoyi.ss.device.domain.vo.DeviceVO;
import com.ruoyi.ss.device.service.DeviceService;
import com.ruoyi.ss.payBill.domain.PayBillQuery;
import com.ruoyi.ss.payBill.domain.PayBillVO;
import com.ruoyi.ss.payBill.domain.dto.PayBillRefundDTO;
import com.ruoyi.ss.payBill.domain.enums.PayBillBstType;
import com.ruoyi.ss.payBill.domain.vo.DoPayVO;
import com.ruoyi.ss.payBill.service.PayBillConverter;
import com.ruoyi.ss.payBill.service.PayBillService;
import com.ruoyi.ss.receiveBill.domain.ReceiveBill;
import com.ruoyi.ss.receiveBill.domain.enums.ReceiveBillStatus;
import com.ruoyi.ss.receiveBill.domain.enums.ReceiveBillType;
import com.ruoyi.ss.receiveBill.service.ReceiveBillService;
import com.ruoyi.ss.recordBalance.domain.enums.RecordBalanceBstType;
import com.ruoyi.ss.risk.service.RiskService;
import com.ruoyi.ss.store.domain.StoreVo;
import com.ruoyi.ss.suit.domain.SuitVO;
import com.ruoyi.ss.suit.domain.enums.SuitFeeMode;
import com.ruoyi.ss.suit.domain.enums.SuitFeeType;
import com.ruoyi.ss.suit.domain.enums.SuitTimeUnit;
import com.ruoyi.ss.suit.service.SuitService;
import com.ruoyi.ss.transactionBill.domain.TransactionBill;
import com.ruoyi.ss.transactionBill.domain.TransactionBillQuery;
import com.ruoyi.ss.transactionBill.domain.bo.EndUseBO;
import com.ruoyi.ss.transactionBill.domain.bo.RechargeBO;
import com.ruoyi.ss.transactionBill.domain.bo.WithdrawBO;
import com.ruoyi.ss.transactionBill.domain.dto.BillRefundDTO;
import com.ruoyi.ss.transactionBill.domain.dto.RechargeDTO;
import com.ruoyi.ss.transactionBill.domain.dto.RechargePayBO;
import com.ruoyi.ss.transactionBill.domain.dto.WithdrawApprovalDTO;
import com.ruoyi.ss.transactionBill.domain.dto.WithdrawDTO;
import com.ruoyi.ss.transactionBill.domain.enums.RechargeBillShowMobileStatus;
import com.ruoyi.ss.transactionBill.domain.enums.RechargeCloseStatus;
import com.ruoyi.ss.transactionBill.domain.enums.RechargeVoiceStatus;
import com.ruoyi.ss.transactionBill.domain.enums.TransactionBillDeviceRechargeStatus;
import com.ruoyi.ss.transactionBill.domain.enums.TransactionBillGroupBy;
import com.ruoyi.ss.transactionBill.domain.enums.TransactionBillStatus;
import com.ruoyi.ss.transactionBill.domain.enums.TransactionBillType;
import com.ruoyi.ss.transactionBill.domain.enums.WithdrawType;
import com.ruoyi.ss.transactionBill.domain.vo.PrepayPriceVO;
import com.ruoyi.ss.transactionBill.domain.vo.TransactionAmountVO;
import com.ruoyi.ss.transactionBill.domain.vo.TransactionBillVO;
import com.ruoyi.ss.transactionBill.domain.vo.TransactionDailyAmountVO;
import com.ruoyi.ss.transactionBill.domain.vo.UserWithdrawServiceVO;
import com.ruoyi.ss.transactionBill.mapper.TransactionBillMapper;
import com.ruoyi.ss.transactionBill.service.TransactionAssembler;
import com.ruoyi.ss.transactionBill.service.TransactionBillService;
import com.ruoyi.ss.transactionBill.service.TransactionBillValidator;
import com.ruoyi.ss.transactionBill.service.WithdrawValidator;
import com.ruoyi.ss.transactionBill.utils.RechargeUtils;
import com.ruoyi.ss.transfer.domain.TransferVO;
import com.ruoyi.ss.transfer.interfaces.AfterTransfer;
import com.ruoyi.ss.transfer.service.TransferConverter;
import com.ruoyi.ss.transfer.service.TransferService;
import com.ruoyi.ss.user.domain.SmUserVO;
import com.ruoyi.ss.user.service.UserService;
import com.ruoyi.ss.vip.domain.VipVO;
import com.ruoyi.ss.vip.service.VipService;
import com.ruoyi.ss.vip.utils.VipUtil;
import com.ruoyi.system.domain.enums.config.ConfigKey;
import com.ruoyi.system.service.ISysConfigService;
import com.ruoyi.task.bill.BillDelayedManager;

import lombok.extern.slf4j.Slf4j;

/**
 * 充值记录Service业务层处理
 */
@Service("transactionBillService")
@Slf4j
public class TransactionBillServiceImpl implements TransactionBillService, AfterTransfer {
    @Autowired
    private TransactionBillMapper transactionBillMapper;

    @Autowired
    private ChannelWithdrawService channelWithdrawService;

    @Autowired
    private TransactionBillValidator transactionBillValidator;

    @Autowired
    private DeviceService deviceService;

    @Autowired
    private UserService userService;

    @Autowired
    private TransferService transferService;

    @Autowired
    private TransferConverter transferConverter;

    @Autowired
    private BillDelayedManager billDelayedManager;

    @Autowired
    private RedisLock redisLock;

    @Autowired
    private ScheduledExecutorService scheduledExecutorService;

    @Autowired
    private TransactionTemplate transactionTemplate;

    @Autowired
    private PayBillService payBillService;

    @Autowired
    private PayBillConverter payBillConverter;

    @Autowired
    private IotService iotService;

    @Autowired
    private ISysConfigService sysConfigService;

    @Autowired
    private WithdrawValidator withdrawValidator;

    @Autowired
    private BonusService bonusService;

    @Autowired
    private TransactionAssembler transactionAssembler;

    @Autowired
    private ReceiveBillService receiveBillService;

    @Autowired
    private RiskService riskService;

    @Autowired
    private BillEleRecordService billEleRecordService;

    @Autowired
    private BillEleRecordConverter billEleRecordConverter;

    @Autowired
    private SuitService suitService;

    @Autowired
    private VipService vipService;

    @Autowired
    private BonusRefundConverter bonusRefundConverter;

    @Autowired
    private BonusRefundService bonusRefundService;

    /**
     * 查询充值记录
     *
     * @param billId 充值记录主键
     * @return 充值记录
     */
    @Override
    public TransactionBillVO selectSmTransactionBillByBillId(Long billId) {
        return transactionBillMapper.selectSmTransactionBillByBillId(billId);
    }

    /**
     * 查询充值记录列表
     *
     * @param smTransactionBillQuery 充值记录查询条件
     * @return 充值记录
     */
    @Override
    public List<TransactionBillVO> selectSmTransactionBillList(TransactionBillQuery smTransactionBillQuery) {
        return transactionBillMapper.selectSmTransactionBillList(smTransactionBillQuery);
    }

    /**
     * 新增充值记录
     *
     * @param transactionBill 充值记录
     * @return 结果
     */
    @Override
    public int insertSmTransactionBill(TransactionBill transactionBill) {
        transactionBill.setCreateTime(DateUtils.getNowDate());
        transactionBill.setBillNo(String.valueOf(SnowFlakeUtil.newId()));
        return transactionBillMapper.insertSmTransactionBill(transactionBill);
    }

    /**
     * 修改充值记录
     *
     * @param transactionBill 充值记录
     * @return 结果
     */
    @Override
    public int updateSmTransactionBill(TransactionBill transactionBill) {
        return transactionBillMapper.updateSmTransactionBill(transactionBill);
    }

    /**
     * 批量删除充值记录
     *
     * @param billIds 需要删除的充值记录主键
     * @return 结果
     */
    @Override
    public int deleteSmTransactionBillByBillIds(Long[] billIds) {
        return transactionBillMapper.deleteSmTransactionBillByBillIds(billIds);
    }

    /**
     * 删除充值记录信息
     *
     * @param billId 充值记录主键
     * @return 结果
     */
    @Override
    public int deleteSmTransactionBillByBillId(Long billId) {
        return transactionBillMapper.deleteSmTransactionBillByBillId(billId);
    }

    /**
     * 查询账单统计
     *
     * @param dto
     * @return
     */
    @Override
    public List<BillCountVo> selectCount(TransactionBillQuery dto) {
        return transactionBillMapper.selectCount(dto);
    }

    @Override
    public String addOrder(RechargeBO bo) {
        ServiceUtil.assertion(bo == null || bo.getDevice() == null || bo.getDevice().getDeviceId() == null, "设备不存在");
        Long deviceId = bo.getDevice().getDeviceId();

        // 加锁
        ServiceUtil.assertion(!redisLock.lock(RedisLockKey.ADD_RECHARGE_ORDER, deviceId), "当前使用该设备人数较多，请稍后再试");
        try {
            // 拉取设备信息
            deviceService.pullDeviceInfo(bo.getDevice(), null);

            // 生成订单
            TransactionBill order = parseToOrder(bo);

            transactionTemplate.execute(status -> {
                // 收取月费
                int monthFee = receiveBillService.genBillByMonthAndPay(bo.getMch(), bo.getDevice());
                ServiceUtil.assertion(monthFee != 1, "月费收取失败，请联系商户处理");

                // 扣减会员次数
                VipVO vip = bo.getVip();
                if (vip != null) {
                    int use = vipService.useVip(vip);
                    ServiceUtil.assertion(use != 1, "ID为%s的会员使用失败", vip.getId());
                }

                // 新增订单
                int insert = this.insertSmTransactionBill(order);
                ServiceUtil.assertion(insert != 1, "下单失败");

                return insert;
            });

            return order.getBillNo();
        } finally {
            // 解锁
            redisLock.unlock(RedisLockKey.ADD_RECHARGE_ORDER, deviceId);
        }
    }

    @Override
    public int receiveMchShowMobileAmount(TransactionBillVO bill) {
        ServiceUtil.assertion(bill == null, "订单不存在");
        // 若未开启该功能，则跳过
        if (bill.getMchShowMobile() == null || !bill.getMchShowMobile()) {
            return 1;
        }

        Integer result = transactionTemplate.execute(status -> {
            // 创建应收账
            ReceiveBill receive = new ReceiveBill();
            receive.setUserId(bill.getMchId());
            receive.setDeviceId(bill.getDeviceId());
            receive.setType(ReceiveBillType.MOBILE.getType());
            receive.setStatus(ReceiveBillStatus.PAID.getStatus());
            receive.setBillTime(LocalDateTime.now());
            receive.setAmount(bill.getMchShowMobilePrice());
            receive.setDescription("商户获取用户手机号订单：" + bill.getBillNo());
            receive.setReceivedAmount(bill.getMchShowMobilePrice());
            receive.setChannelId(8L);   // 暂时固定为8（余额）
            int insert = receiveBillService.insertReceiveBill(receive);
            ServiceUtil.assertion(insert != 1, "创建收款失败");

            // 收款
            userService.subtractBalance(
                    receive.getUserId(),
                    receive.getAmount(),
                    false,
                    receive.getDescription(),
                    RecordBalanceBstType.RECEIVABLE,
                    receive.getBillId());

            // 修改订单缴费状态
            TransactionBill data = new TransactionBill();
            data.setMchShowMobileStatus(RechargeBillShowMobileStatus.PAID.getStatus());
            TransactionBillQuery query = new TransactionBillQuery();
            query.setBillId(bill.getBillId());
            query.setMchShowMobileStatus(RechargeBillShowMobileStatus.UNPAID.getStatus());
            int update = this.updateByQuery(data, query);
            ServiceUtil.assertion(update != 1, "修改订单缴费状态失败，请刷新后重试");

            return update;
        });

        return result == null ? 0 : result;
    }

    @Override
    public List<TransactionBillVO> selectStaffDeviceList(TransactionBillQuery query) {
        query.setInStaff(true);
        return this.selectSmTransactionBillList(query);
    }

    @Override
    public BigDecimal selectSumOfMoneyWithoutRefund(TransactionBillQuery query) {
        return transactionBillMapper.selectSumOfMoneyWithoutRefund(query);
    }

    @Override
    public List<TransactionDailyAmountVO> selectDailyAmount(TransactionBillQuery query) {
        return transactionBillMapper.selectDailyAmount(query);
    }

    @Override
    public int batchUpdateSuitEndTime(List<Long> billIds, LocalDateTime time) {
        return transactionBillMapper.batchUpdateSuitEndTime(billIds, time);
    }

    @Override
    public List<LongDecimalVO> selectSumOfMoneyGroupByMchId(TransactionBillQuery query) {
        return transactionBillMapper.selectSumOfMoneyGroupByMchId(query);
    }

    @Override
    public List<LongDecimalVO> selectSumOfMoneyGroupByUserId(TransactionBillQuery query) {
        return transactionBillMapper.selectSumOfMoneyGroupByUserId(query);
    }

    @Override
    public List<JSONObject> selectCountGroupBy(TransactionBillQuery query, String groupBy) {
        return transactionBillMapper.selectCountGroupBy(query, groupBy);
    }

    // 转换为订单所需的数据
    private TransactionBill parseToOrder(RechargeBO bo) {
        // 校验
        ServiceUtil.assertion(transactionBillValidator.preAddOrder(bo));
        RechargeDTO dto = bo.getParams();
        DeviceVO device = bo.getDevice();
        SmUserVO mch = bo.getMch();
        SuitVO suit = bo.getSuit();
        SmUserVO user = bo.getUser();
        StoreVo store = bo.getStore();
        PrepayPriceVO price = bo.getPrice();
        VipVO vip = bo.getVip();

        // 创建订单
        TransactionBill order = new TransactionBill();
        bo.setOrder(order);

        // 基础信息
        order.setType(TransactionBillType.RECHARGE.getType()); // 类型：充值订单
        order.setDeviceRechargeStatus(TransactionBillDeviceRechargeStatus.UN_RECHARGE.getStatus()); // 设备状态：未充值
        order.setVersion(2); // 订单版本
        order.setCloseStatus(RechargeCloseStatus.SUCCESS.getStatus());
        order.setCloseResult("预计成功");
        order.setStatus(TransactionBillStatus.UNPAID.getStatus()); // 状态：未支付
        // 订单金额
        order.setMoney(price.getPayPrice());
        order.setDiscountAmount(price.getDiscountAmount());

        // 会员信息
        if (vip != null) {
            order.setVipId(vip.getId());
            order.setVipDiscount(vip.getDiscount());
            order.setVipName(vip.getVipLevelName());
        }

        // 用户信息
        order.setUserId(user.getUserId());
        order.setUserMobile(user.getPhonenumber());

        // 商户信息
        order.setMchId(mch.getUserId());
        order.setMchShowMobile(mch.getShowBillMobile());
        order.setMchShowMobilePrice(mch.getShowBillMobilePrice());
        order.setMchShowMobileStatus(RechargeBillShowMobileStatus.UNPAID.getStatus());

        // 套餐信息
        order.setSuitId(suit.getSuitId());
        order.setSuitTime(suit.getValue());
        order.setSuitTimeUnit(suit.getTimeUnit());
        order.setSuitFeeType(suit.getFeeType());
        order.setSuitFeeMode(suit.getFeeMode());
        order.setSuitPrice(suit.getPrice());
        order.setSuitGearAmount(suit.getGearAmount());
        order.setSuitGearTime(suit.getGearTime());
        order.setSuitName(suit.getName());
        order.setSuitEnableLowPowerClose(suit.getEnabledLowPowerClose());
        order.setSuitLowPower(suit.getLowPower());
        order.setSuitEnabledVoid(suit.getEnabledVoice());
        order.setSuitVoidMinute(suit.getVoiceMinutes());
        order.setSuitDeposit(suit.getDeposit());

        // 设备信息
        order.setDeviceNo(device.getDeviceNo());
        order.setDeviceId(device.getDeviceId());
        order.setDeviceName(device.getDeviceName());
        order.setDeviceMac(device.getMac());
        order.setDeviceMac2(device.getMac2());
        order.setDeviceProductId(device.getModelProductId());
        order.setDeviceServiceMode(device.getServiceMode());
        order.setAgentId(device.getAgentId());
        order.setAgentMobile(device.getAgentMobile());

        // 店铺信息
        if (store != null) {
            order.setStoreId(store.getStoreId());
            order.setStoreName(store.getName());
            order.setStoreAddress(String.format("%s%s%s%s", store.getProvince(), store.getCity(), store.getCounty(),
                    store.getAddress()));
        }

        // 支付过期时间 5min
        long expireTime = TimeUnit.MILLISECONDS.convert(Constants.BILL_UNPAID_TIMEOUT, Constants.BILL_UNPAID_TIMEUNIT)
                + System.currentTimeMillis();
        order.setExpireTime(new Date(expireTime));

        return order;
    }

    @Override
    public String addWithdraw(WithdrawBO bo) {
        // 参数校验
        Long userId = bo.getDto().getUserId();
        ServiceUtil.assertion(userId == null, "参数错误：用户id为空");
        // 加锁
        ServiceUtil.assertion(!redisLock.lock(RedisLockKey.ADD_WITHDRAW, userId), "请勿频繁操作提现");
        try {
            WithdrawDTO dto = bo.getDto();
            ChannelWithdrawVO channel = bo.getChannel();
            SmUserVO user = bo.getUser();
            AccountVO account = bo.getAccount();

            ServiceUtil.assertion(user == null, "用户不存在");
            ServiceUtil.assertion(user.getIsReal() == null || !user.getIsReal(), "用户未实名认证，无法提现");

            // 判断用户是否被限制提现
            withdrawValidator.checkWithdrawRisk(user);

            // 风控规则，判断用户是否有风险
            boolean enabled = sysConfigService.getBoolean(ConfigKey.RISK_WITHDRAW_ENABLED); // 是否开启提现风控

            // 判断是否有风险
            boolean hasRisk = enabled && withdrawValidator.hasRisk(bo);
            if (hasRisk) {
                // 若用户风险次数已达到阈值，将用户标记为提现风险
                int riskWithdrawCount = sysConfigService.getInt(ConfigKey.RISK_WITHDRAW_COUNT);
                if (user.getRiskCount() + 1 >= riskWithdrawCount) {
                    riskService.limitWithdraw(userId, "根据风控规则判断，您的提现具有风险");
                    // 返回错误
                    throw new ServiceException("提现具有风险，无法提现", ServiceCode.RISK_WITHDRAW.getCode());
                }
            }

            // 判断今天提现成功和正在审核中的提现是否超过限额
            String dailyLimitStr = sysConfigService.selectConfigByKey(ConfigKey.DAILY_WITHDRAW_AMOUNT.getKey());
            String dailyLimitCountStr = sysConfigService.selectConfigByKey(ConfigKey.DAILY_WITHDRAW_COUNT.getKey());
            if (StringUtils.hasText(dailyLimitStr) || StringUtils.hasText(dailyLimitCountStr)) {
                // 查询条件
                TransactionBillQuery query = new TransactionBillQuery();
                query.setType(TransactionBillType.WITHDRAW.getType());
                query.setStatusList(TransactionBillStatus.countOfLimit());
                query.setCreateDate(LocalDate.now());
                query.setUserId(user.getUserId());

                // 每日限额
                if (StringUtils.hasText(dailyLimitStr)) {
                    BigDecimal dailyLimit = new BigDecimal(dailyLimitStr);
                    BigDecimal current = this.selectSumOfMoney(query);
                    if (current == null) {
                        current = BigDecimal.ZERO;
                    }
                    ServiceUtil.assertion(current.add(dto.getMoney()).compareTo(dailyLimit) > 0,
                            "当前用户提现金额已超过每日限额：" + dailyLimit + "元");
                }
                // 每日限次
                if (StringUtils.hasText(dailyLimitCountStr)) {
                    int dailyLimitCount = Integer.parseInt(dailyLimitCountStr);
                    int count = this.selectSimpleCount(query);
                    ServiceUtil.assertion(count + 1 > dailyLimitCount, "当前用户提现次数已超过每日限制：" + dailyLimitCount + "次");
                }
            }

            // 处理提现手续费
            ServiceUtil.assertion(channel == null, "提现渠道不存在");
            ServiceUtil.assertion(channel.getEnabled() == null || !channel.getEnabled(), "提现渠道不可用");
            ServiceUtil.assertion(channel.getMinAmount().compareTo(dto.getMoney()) > 0,
                    String.format("提现金额不能低于%s元", channel.getMinAmount()));
            ServiceUtil.assertion(channel.getMaxAmount().compareTo(dto.getMoney()) < 0,
                    String.format("提现金额不能高于%s元", channel.getMaxAmount()));
            UserWithdrawServiceVO serviceInfo = this.getUserWithdrawService(user, channel);
            ServiceUtil.assertion(serviceInfo == null, "服务费配置出错，请联系管理员处理");
            ServiceUtil.assertion(StringUtils.isBlank(serviceInfo.getServiceType()), "服务费配置出错，请联系管理员处理");
            ServiceUtil.assertion(serviceInfo.getServiceRate() == null, "服务费配置出错，请联系管理员处理");
            ServiceUtil.assertion(!Objects.equals(serviceInfo.getServiceType(), dto.getServiceType()),
                    "服务费收取方式发生变化，请刷新后重试");
            ServiceUtil.assertion(serviceInfo.getServiceRate().compareTo(dto.getServiceRate()) != 0, "服务费发生变化，请刷新后重试");

            // 计算服务费
            BigDecimal serviceRecharge = this.calcWithdrawServiceCharge(serviceInfo, dto.getMoney());
            ServiceUtil.assertion(BigDecimal.ZERO.compareTo(serviceRecharge) > 0, "服务费不允许小于0");
            ServiceUtil.assertion(serviceRecharge.compareTo(dto.getServiceCharge()) != 0, "服务费计算不一致，请重新申请");
            // 到账金额
            BigDecimal arrivalAmount = dto.getMoney().subtract(serviceRecharge); // 到账金额
            ServiceUtil.assertion(arrivalAmount.compareTo(dto.getArrivalAmount()) != 0, "到账金额计算不一致，请重新申请");

            // 创建申请订单
            TransactionBill bill = new TransactionBill();
            bill.setUserId(userId);
            bill.setType(TransactionBillType.WITHDRAW.getType());
            bill.setMchId(userId);
            bill.setMoney(dto.getMoney());
            bill.setArrivalAmount(arrivalAmount);
            bill.setServiceCharge(serviceRecharge);
            bill.setStatus(TransactionBillStatus.WITHDRAW_APPROVING.getStatus()); // 审核中
            bill.setAccountNo(account.getAccountNo());
            bill.setChannelId(channel.getChannelId());
            bill.setWithdrawType(WithdrawType.ONLINE.getType());
            bill.setChannelCost(channel.getCostRate().multiply(bill.getMoney()).divide(new BigDecimal(100), 2,
                    RoundingMode.HALF_UP)); // 渠道成本
            bill.setAfterBalance(user.getBalance().subtract(dto.getMoney())); // 剩余金额
            bill.setWithdrawAccount(account);

            transactionTemplate.execute(status -> {
                // 提现申请
                int insert = this.insertSmTransactionBill(bill);
                ServiceUtil.assertion(insert != 1, "提现申请失败");

                // 减少余额，并判断提现金额是否超额（减少的是交易金额）
                userService.subtractBalance(userId, bill.getMoney(), String.format("提现申请:%s", bill.getBillNo()),
                        RecordBalanceBstType.WITHDRAW, bill.getBillId());

                // 若本次提现具有风险，则累计一次风险次数
                if (hasRisk) {
                    userService.addRiskCount(userId, 1);
                }
                return insert;
            });

            // 异步操作：当提现申请金额免审核且为线上打款时，直接通过
            try {
                String noverifyAmountStr = sysConfigService
                        .selectConfigByKey(ConfigKey.NOVERIFY_WITHDRAW_SINGLE.getKey());
                if (StringUtils.hasText(noverifyAmountStr)) {
                    BigDecimal noverifyAmount = new BigDecimal(noverifyAmountStr);
                    if (noverifyAmount.compareTo(bill.getMoney()) >= 0) {
                        scheduledExecutorService.schedule(() -> {
                            WithdrawApprovalDTO passDto = new WithdrawApprovalDTO();
                            passDto.setBillId(bill.getBillId());
                            passDto.setWithdrawType(WithdrawType.ONLINE.getType());
                            passDto.setRemark("免审核通过");
                            this.passWithdraw(passDto);
                        }, 0, TimeUnit.SECONDS);
                    }
                }
            } catch (Exception e) {
                log.error(e.getMessage());
            }

            return bill.getBillNo();
        } finally {
            redisLock.unlock(RedisLockKey.ADD_WITHDRAW, userId);
        }

    }

    private BigDecimal calcWithdrawServiceCharge(UserWithdrawServiceVO serviceInfo, BigDecimal money) {
        BigDecimal serviceRecharge;
        if (WithdrawServiceType.PERCENT.getType().equals(serviceInfo.getServiceType())) {
            serviceRecharge = money.multiply(serviceInfo.getServiceRate()).divide(new BigDecimal(100), 2,
                    RoundingMode.HALF_UP); // 服务费
        } else if (WithdrawServiceType.FIXED.getType().equals(serviceInfo.getServiceType())) {
            serviceRecharge = serviceInfo.getServiceRate();
        } else {
            throw new ServiceException("服务费配置出错，请联系管理员处理");
        }
        return serviceRecharge;
    }

    /**
     * 获取用户提现服务费
     * 用户 > 渠道
     */
    private UserWithdrawServiceVO getUserWithdrawService(SmUserVO user, ChannelWithdrawVO channel) {
        if (user != null && StringUtils.hasText(user.getWithdrawServiceType())
                && user.getWithdrawServiceRate() != null) {
            return new UserWithdrawServiceVO(user.getWithdrawServiceType(), user.getWithdrawServiceRate());
        } else if (channel != null && StringUtils.hasText(channel.getServiceType())
                && channel.getServiceRate() != null) {
            return new UserWithdrawServiceVO(channel.getServiceType(), channel.getServiceRate());
        }
        return null;
    }

    /**
     * 提现审核通过
     *
     * @param dto id
     */
    @Override
    public int passWithdraw(WithdrawApprovalDTO dto) {
        ServiceUtil.assertion(dto.getBillId() == null, "提现申请ID不允许为空");
        Long lockKey = dto.getBillId();
        ServiceUtil.assertion(!redisLock.lock(RedisLockKey.APPROVAL_WITHDRAW, lockKey), "该提现申请正在审核，请刷新后重试");
        try {
            Integer result = transactionTemplate.execute(status -> {
                int update = 0;
                // 线下打款，修改状态为已打款
                if (WithdrawType.OFFLINE.getType().equals(dto.getWithdrawType())) {
                    update = this.approvalWithdraw(dto, TransactionBillStatus.WITHDRAW_SUCCESS);
                }
                // 线上打款，修改状态为打款中
                else if (WithdrawType.ONLINE.getType().equals(dto.getWithdrawType())) {
                    update = this.approvalWithdraw(dto, TransactionBillStatus.WITHDRAW_PAYING);
                } else {
                    throw new ServiceException("不支持的提现打款方式");
                }
                ServiceUtil.assertion(update != 1, "提现审核失败，请刷新后重试");

                // 线上打款，发起打款
                if (WithdrawType.ONLINE.getType().equals(dto.getWithdrawType())) {
                    TransactionBillVO withdraw = this.selectWithdrawById(dto.getBillId());
                    boolean pay = this.startPayOnline(withdraw);
                    ServiceUtil.assertion(!pay, "发起打款失败");
                }

                return update;
            });

            return result == null ? 0 : result;
        } finally {
            redisLock.unlock(RedisLockKey.APPROVAL_WITHDRAW, lockKey);
        }
    }

    /**
     * 提现线上打款
     */
    private boolean startPayOnline(TransactionBillVO bill) {
        ServiceUtil.assertion(bill == null, "单据不存在");
        ServiceUtil.assertion(TransactionBillStatus.WITHDRAW_PASSED.getStatus().equals(bill.getStatus()), "当前提现单据状态异常");
        ServiceUtil.assertion(StringUtils.isBlank(bill.getAccountNo()), "提现账号异常");

        // 生成转账单
        TransferVO vo = transferConverter.toVo(bill);

        Boolean result = transactionTemplate.execute(status -> {
            // 插入数据
            int insert = transferService.insertWithDetail(vo);
            ServiceUtil.assertion(insert != 1, "新增转账单失败");

            // 发起转账
            boolean requestResult = transferService.requestTransfer(vo.getBatchNo());
            ServiceUtil.assertion(!requestResult, "发起转账失败");

            return true;
        });

        return result != null && result;
    }

    /**
     * 审核操作
     */
    private int approvalWithdraw(WithdrawApprovalDTO dto, TransactionBillStatus status) {
        Integer result = transactionTemplate.execute(s -> {
            TransactionBill data = new TransactionBill();
            data.setStatus(status.getStatus());
            data.setRemark(dto.getRemark());
            data.setPayPicture(dto.getPayPicture());
            data.setWithdrawType(dto.getWithdrawType());
            data.setOfflineImage(dto.getOfflineImage());

            // 线下打款并且状态为已打款，则修改支付时间为当前
            if (WithdrawType.OFFLINE.getType().equals(dto.getWithdrawType())
                    && TransactionBillStatus.WITHDRAW_SUCCESS.equals(status)) {
                data.setPayTime(DateUtils.getNowDate());
            }

            TransactionBillQuery query = new TransactionBillQuery();
            query.setBillId(dto.getBillId());
            query.setType(TransactionBillType.WITHDRAW.getType());
            query.setStatus(TransactionBillStatus.WITHDRAW_APPROVING.getStatus());
            int update = this.updateByQuery(data, query);
            ServiceUtil.assertion(update != 1, "提现审核失败");

            return update;
        });

        return result == null ? 0 : result;
    }

    @Override
    public boolean rejectWithdraw(WithdrawApprovalDTO dto) {
        ServiceUtil.assertion(dto.getBillId() == null, "提现申请ID不允许为空");
        Long lockKey = dto.getBillId();
        ServiceUtil.assertion(!redisLock.lock(RedisLockKey.APPROVAL_WITHDRAW, lockKey), "该提现申请正在审核，请刷新后重试");
        try {
            transactionTemplate.execute(status -> {
                // 审核
                int updateCount = this.approvalWithdraw(dto, TransactionBillStatus.WITHDRAW_REJECTED);
                ServiceUtil.assertion(updateCount != 1, "提现审核失败，请刷新后重试");

                // 返还客户余额
                TransactionBill bill = transactionBillMapper.selectSmTransactionBillByBillId(dto.getBillId());
                ServiceUtil.assertion(bill == null || bill.getUserId() == null, "数据不存在");
                userService.addBalance(bill.getUserId(), bill.getMoney(), String.format("提现驳回: %s", bill.getBillNo()),
                        RecordBalanceBstType.WITHDRAW, bill.getBillId());

                return updateCount;
            });

            return true;
        } finally {
            redisLock.unlock(RedisLockKey.APPROVAL_WITHDRAW, lockKey);
        }
    }

    @Override
    public List<BillCountVo> selectLandlordCount(TransactionBillQuery dto) {
        List<BillCountVo> list = this.selectCount(dto);

        // 若startDate与endDate不为空，则将其中间数据补全，不让其为空
        if (dto.getStartDate() != null && dto.getEndDate() != null
                && Objects.equals(dto.getGroupBy(), TransactionBillGroupBy.create_date.name())) {
            List<BillCountVo> newList = new ArrayList<>();
            LocalDate i = dto.getStartDate();
            while (!i.isAfter(dto.getEndDate())) {
                Date finalI = DateUtils.toDate(i);
                BillCountVo count = list.stream().filter(
                        item -> DateUtils.getYYYY_MM_DD(item.getCreateDate()).equals(DateUtils.getYYYY_MM_DD(finalI)))
                        .findFirst().orElse(null);
                if (count == null) {
                    count = new BillCountVo();
                    count.setCreateDate(finalI);
                    count.setServiceCharge(BigDecimal.ZERO);
                    count.setWithdraw(BigDecimal.ZERO);
                    count.setRecharge(BigDecimal.ZERO);
                    count.setCreateYear(DateUtils.getYear(finalI));
                    count.setCreateMonth(DateUtils.getMonth(finalI));
                    count.setCreateDay(DateUtils.getDay(finalI));
                    count.setCreateYearMonth(DateUtils.getYYYY_MM(finalI));
                }
                newList.add(count);
                i = i.plusDays(1);
            }

            // 列表排序
            newList.sort(Comparator.comparing(BillCountVo::getCreateDate));
            list = newList;
        }

        return list;
    }

    /**
     * 刷新支付结果
     *
     * @param billId
     * @return
     */
    @Transactional
    public int refreshPayResult(Long billId) {
        return this.refreshPayResult(this.selectSmTransactionBillByBillId(billId));
    }

    public int refreshPayResult(TransactionBillVO bill) {
        return this.refreshPayResult(Collections.singletonList(bill));
    }

    /**
     * 订单设备充值
     *
     * @param billId 订单ID
     */
    @Override
    public boolean rechargeDevice(Long billId) {
        ServiceUtil.assertion(billId == null, "参数错误,billId不允许为空");

        TransactionBillVO bill = transactionBillMapper.selectSmTransactionBillByBillId(billId);
        ServiceUtil.assertion(bill == null || !TransactionBillType.RECHARGE.getType().equals(bill.getType()),
                "不存在ID为%s的充值订单", billId);
        ServiceUtil.assertion(!TransactionBillStatus.SUCCESS.getStatus().equals(bill.getStatus()), "订单%s未支付",
                bill.getBillNo());
        ServiceUtil.assertion(
                !TransactionBillDeviceRechargeStatus.canRecharge().contains(bill.getDeviceRechargeStatus()),
                "订单%s当前设备状态不允许充值", bill.getBillNo());

        // 获取最新设备信息
        DeviceVO device = deviceService.selectById(bill.getDeviceId());
        deviceService.pullDeviceInfo(device, null);

        // 充值设备
        Boolean iotResult = transactionTemplate.execute(status -> {
            // 同步设备余额
            CommandResponse res = null;
            if (SuitFeeType.rechargeTimeList().contains(bill.getSuitFeeType())) {
                res = deviceService.syncTime(bill.getDeviceId(), LocalDateTime.now(), "充值订单：" + bill.getBillNo());
            } else if (SuitFeeType.rechargeEleList().contains(bill.getSuitFeeType())) {
                res = deviceService.syncEle(bill.getDeviceId(), "充值订单：" + bill.getBillNo());
            }

            // 充值结果
            TransactionBill data = new TransactionBill();
            if (res != null && res.isSuccess()) {
                data.setDeviceRechargeStatus(TransactionBillDeviceRechargeStatus.SUCCESS.getStatus());
                data.setOpenMsg("成功");
            } else {
                data.setDeviceRechargeStatus(TransactionBillDeviceRechargeStatus.FAIL.getStatus());
                if (res != null) {
                    data.setOpenMsg(res.getMsg());
                } else {
                    data.setOpenMsg("未知错误");
                }
            }

            // 修改设备充值状态
            TransactionBillQuery query = new TransactionBillQuery();
            query.setBillId(bill.getBillId());
            query.setType(TransactionBillType.RECHARGE.getType());
            query.setDeviceRechargeStatusList(TransactionBillDeviceRechargeStatus.canRecharge());
            int updateRecharge = this.updateByQuery(data, query);
            ServiceUtil.assertion(updateRecharge != 1, "设备充值状态发生变化，请稍后重试");

            return true;
        });

        return iotResult != null && iotResult;
    }

    /**
     * 在设备充值成功前，更新套餐使用信息
     */
    private int updateSuitInfoBeforeDevice(TransactionBillVO bill, DeviceVO device) {
        if (bill == null || device == null) {
            return 0;
        }

        LocalDateTime now = LocalDateTime.now();
        LocalDateTime startTime = device.getExpireTime() == null || now.isAfter(device.getExpireTime()) ? now
                : device.getExpireTime();
        BigDecimal startEle = device.getTotalElectriQuantity();

        TransactionBill data = new TransactionBill();
        data.setBillId(bill.getBillId());
        data.setSuitStartTime(startTime);
        data.setSuitStartEle(startEle);

        // 充值时长
        if (SuitFeeType.TIME.getType().equals(bill.getSuitFeeType())) {
            // 计算开始使用的时间
            LocalDateTime endTime = startTime.plusSeconds(bill.getRechargeSeconds());
            data.setSuitEndTime(endTime);
            data.setSuitExpireTime(endTime);
        }
        // 充值电量
        else if (SuitFeeType.COUNT.getType().equals(bill.getSuitFeeType())) {
            BigDecimal endEle = startEle.add(bill.getRechargeEle());
            data.setSuitEndEle(endEle);
        }
        return transactionBillMapper.updateSmTransactionBill(data);
    }

    /**
     * 尝试设置语音播报
     */
    @Override
    public void trySetVoice(TransactionBillVO bill, int tryCount) {
        if (tryCount <= 0) {
            return;
        }
        try {
            transactionTemplate.execute(status -> {
                // 设置为成功
                int update = this.updateVoiceResult(bill.getBillId(), RechargeVoiceStatus.SUCCESS, "成功");
                ServiceUtil.assertion(update != 1, "更新订单信息失败");

                // 发送命令
                boolean res = false;
                if (bill.getSuitEnabledVoid() == null || !bill.getSuitEnabledVoid()
                        || bill.getSuitVoidMinute() == null) {
                    res = iotService.setVoice(bill, 0L, "关闭订单语音:" + bill.getBillNo());
                } else {
                    res = iotService.setVoice(bill,
                            bill.getSuitVoidMinute().multiply(BigDecimal.valueOf(60)).longValue(),
                            "开启订单语音:" + bill.getBillNo());
                }
                ServiceUtil.assertion(!res, "设备设置语音失败");

                return res;
            });
        } catch (Exception e) {
            log.info("订单设置设备语音失败：{}, 剩余次数:{}", bill.getBillNo(), tryCount - 1);
            if (tryCount <= 1) {
                // 设置为失败
                int update = this.updateVoiceResult(bill.getBillId(), RechargeVoiceStatus.FAIL, e.getMessage());
                ServiceUtil.assertion(update != 1, "更新订单信息失败");
            } else {
                this.trySetVoice(bill, tryCount - 1);
            }
        }
    }

    private int updateVoiceResult(Long billId, RechargeVoiceStatus status, String msg) {
        TransactionBill data = new TransactionBill();
        data.setBillId(billId);
        data.setSuitVoidResult(status.getStatus());
        data.setSuitVoidMsg(msg);
        return transactionBillMapper.updateSmTransactionBill(data);
    }

    private BigDecimal calcTotalEle(DeviceVO device, BigDecimal totalEle) {
        if (totalEle == null || totalEle.compareTo(device.getTotalElectriQuantity()) < 0) {
            return device.getTotalElectriQuantity();
        } else {
            return totalEle;
        }
    }

    private BigDecimal calcTimingAmount(TransactionBillVO order, LocalDateTime endTime, BigDecimal totalEle) {
        ServiceUtil.assertion(order == null, "计算金额出错，订单不存在");
        BigDecimal totalAmount;
        if (SuitFeeType.TIMING_TIME.getType().equals(order.getSuitFeeType())) {
            totalAmount = this.calcTimingTimeAmount(order, endTime);
        } else if (SuitFeeType.TIMING_COUNT.getType().equals(order.getSuitFeeType())) {
            totalAmount = this.calcTimingCountAmount(order);
        } else {
            throw new ServiceException("计算金额出错，套餐收费类型不支持");
        }

        // 最低金额不允许低于最低服务费
        BigDecimal minService = sysConfigService.getBigDecimal(ConfigKey.RECHARGE_MIN_SERVICE);
        if (totalAmount == null || totalAmount.compareTo(minService) < 0) {
            totalAmount = minService;
        }

        return totalAmount;
    }

    @Override
    public int endUse(EndUseBO bo) {
        if (bo == null) {
            return 0;
        }
        TransactionBillVO order = bo.getOrder();
        DeviceVO device = bo.getDevice();
        ServiceUtil.assertion(order == null, "订单不存在");
        ServiceUtil.assertion(order.getIsFinished() != null && order.getIsFinished(), "当前订单已结束，无法操作");
        ServiceUtil.assertion(!TransactionBillStatus.SUCCESS.getStatus().equals(order.getStatus()), "当前订单状态不允许结束");
        ServiceUtil.assertion(device == null, "设备不存在");

        LocalDateTime endTime = LocalDateTime.now(); // 结束使用的时间

        // 结束使用的电量：若蓝牙传过来的值为空或者小于当前电量，则使用当前电量，否则使用蓝牙传输的电量（谁大用谁）
        BigDecimal totalEle = this.calcTotalEle(device, bo.getTotalEle());

        // 若结束时间 > 订单结束时间 或者 结束电量 > 订单结束电量，则表示已经结束使用
        ServiceUtil.assertion(order.getIsFinished() != null && order.getIsFinished(), "当前订单已结束，无法操作");

        Integer result = transactionTemplate.execute(status -> {
            // 修改结束使用的电量
            TransactionBill data = new TransactionBill();
            data.setSuitEndTime(endTime);
            data.setSuitEndEle(totalEle);
            TransactionBillQuery query = new TransactionBillQuery();
            query.setBillId(order.getBillId());
            query.setStatus(TransactionBillStatus.SUCCESS.getStatus());
            query.setIsFinished(false);
            int update = this.updateByQuery(data, query);
            ServiceUtil.assertion(update != 1, "修改订单信息失败，请重试：" + order.getBillNo());

            // 若是分时段电量，则记录一次电量金额
            if (SuitFeeType.TIMING_COUNT.getType().equals(order.getSuitFeeType())) {
                BillEleRecord record = billEleRecordConverter.toPo(order, device, endTime, endTime);
                int insertRecord = billEleRecordService.insertBillEleRecord(record);
                ServiceUtil.assertion(insertRecord != 1, "记录分时段订单%s用电量失败", order.getBillNo());
            }

            return update;
        });

        boolean success = result != null && result == 1; // 是否成功

        // 成功后操作
        if (success) {
            scheduledExecutorService.schedule(() -> {
                // 智能退款
                BigDecimal refundAmount = this.calcRefundAmount(order, endTime, totalEle);
                if (SuitFeeMode.SMART.getMode().equals(order.getSuitFeeMode())) {
                    if (BigDecimal.valueOf(0.01).compareTo(refundAmount) < 0) {
                        try {
                            BillRefundDTO refundDto = new BillRefundDTO();
                            refundDto.setBillId(order.getBillId());
                            refundDto.setRefundAmount(refundAmount);
                            refundDto.setRefundReason(String.format("充值订单%s智能退款%s元", order.getBillNo(), refundAmount));
                            refundDto.setCheckFinish(false);
                            int refund = this.refund(refundDto);
                            ServiceUtil.assertion(refund != 1, "申请退款失败");
                        } catch (Exception e) {
                            log.error("订单{}智能退款失败:{}", order.getBillNo(), e.getMessage());
                        }
                    }
                }

                // 处理分成
                this.handleFinishedBonus(order);

                // 10秒后，执行一次分成
                scheduledExecutorService.schedule(() -> {
                    bonusService.payBonusBeforeTime(LocalDateTime.now());
                }, 10, TimeUnit.SECONDS);
            }, 10, TimeUnit.SECONDS);

        }

        return result == null ? 0 : result;
    }

    private int updateCloseStatus(Long billId, RechargeCloseStatus status, String msg) {
        TransactionBill data = new TransactionBill();
        data.setBillId(billId);
        data.setCloseStatus(status.getStatus());
        data.setCloseResult(msg);
        return transactionBillMapper.updateSmTransactionBill(data);
    }

    @Override
    public BigDecimal calcAmount(Long billId, LocalDateTime endTime, BigDecimal totalEle) {
        TransactionBillVO bill = selectSmTransactionBillByBillId(billId);
        ServiceUtil.assertion(bill == null, "计算金额出错，订单不存在");

        return this.calcAmount(bill, endTime, totalEle);
    }

    private BigDecimal calcAmount(TransactionBillVO bill, LocalDateTime endTime, BigDecimal totalEle) {
        // 计量收费，则获取最新的设备信息
        if (SuitFeeType.COUNT.getType().equals(bill.getSuitFeeType())
                || SuitFeeType.TIMING_COUNT.getType().equals(bill.getSuitFeeType())) {
            DeviceVO device = deviceService.selectById(bill.getDeviceId());
            deviceService.pullDeviceInfo(device, null);
            totalEle = this.calcTotalEle(device, totalEle);
        }

        BigDecimal result = BigDecimal.ZERO;

        // 智能计费
        if (SuitFeeMode.SMART.getMode().equals(bill.getSuitFeeMode())) {
            if (SuitFeeType.timingList().contains(bill.getSuitFeeType())) {
                // 分时段计费
                result = this.calcTimingAmount(bill, endTime, totalEle);
            } else {
                // 非分时段计费
                result = this.calcSmartAmount(bill, endTime, totalEle);
            }
        }
        // 非智能计费
        else {
            result = bill.getMoney();
        }

        // 计算会员折扣
        result = VipUtil.calcDiscountAmount(bill.getVipDiscount(), result);

        // 若需要金额 > 订单金额，则返回订单金额
        if (result.compareTo(bill.getMoney()) > 0) {
            result = bill.getMoney();
        }
        // 若需要的金额 < 0，则返回0
        if (result.compareTo(BigDecimal.ZERO) < 0) {
            result = BigDecimal.ZERO;
        }

        return result;
    }

    @Override
    public BigDecimal selectSumOfMoney(TransactionBillQuery query) {
        return transactionBillMapper.selectSumOfMoney(query);
    }

    /**
     * 计算退款金额
     */
    private BigDecimal calcRefundAmount(TransactionBillVO order, LocalDateTime endTime, BigDecimal totalEle) {

        BigDecimal needAmount = this.calcAmount(order, endTime, totalEle); // 需要的金额
        BigDecimal refundAmount = order.getMoney().subtract(needAmount); // 退款金额

        // 退款金额不允许大于订单金额
        if (refundAmount.compareTo(order.getMoney()) > 0) {
            return order.getMoney();
        }
        // 退款金额不允许小于0
        if (refundAmount.compareTo(BigDecimal.ZERO) < 0) {
            return BigDecimal.ZERO;
        }
        return refundAmount;
    }

    /**
     * 计算智能收费实际使用金额
     */
    private BigDecimal calcSmartAmount(TransactionBillVO order, LocalDateTime endTime, BigDecimal totalEle) {
        // 智能收费时长计费
        if (SuitFeeType.TIME.getType().equals(order.getSuitFeeType())) {
            return this.calcSmartTimeAmount(order, endTime);
        }
        // 智能收费计量收费
        else if (SuitFeeType.COUNT.getType().equals(order.getSuitFeeType())) {
            return this.calcSmartCountAmount(order, totalEle);
        } else {
            throw new ServiceException("不支持的智能收费方式");
        }
    }

    @Override
    public List<TransactionBillVO> selectUnpaidTimingBill(TransactionBillQuery query) {
        query.setStatus(TransactionBillStatus.UNPAID.getStatus());
        query.setSuitFeeTypes(SuitFeeType.timingList());
        query.setSuitFeeMode(SuitFeeMode.SMART.getMode());
        return this.selectSmTransactionBillList(query);
    }

    // 计算智能计量使用金额
    private BigDecimal calcSmartCountAmount(TransactionBillVO order, BigDecimal totalEle) {
        // 若订单不存在，或者 订单开始电量为空，表示未开始使用，则直接返回0
        if (order == null || order.getSuitStartEle() == null) {
            return BigDecimal.ZERO;
        }
        BigDecimal startEle = order.getSuitStartEle();
        BigDecimal usedEle = totalEle.subtract(startEle); // 已使用的电量
        BigDecimal suitEle = new BigDecimal(order.getSuitTime()); // 套餐每周期的电量

        // 计算总使用的周期数，不满足一个周期也算一个周期
        BigDecimal totalRound = usedEle.divide(suitEle, 0, RoundingMode.UP);
        if (totalRound.compareTo(BigDecimal.ZERO) <= 0) {
            totalRound = BigDecimal.ONE;
        }
        // 使用金额 = 使用周期数 * 单价
        return totalRound.multiply(order.getSuitPrice());
    }

    // 计算智能时长的使用金额
    private BigDecimal calcSmartTimeAmount(TransactionBillVO order, LocalDateTime endTime) {
        // 若订单不存在，或者 订单开始时间为空，表示未开始使用，则直接返回0
        if (order == null || order.getSuitStartTime() == null) {
            return BigDecimal.ZERO;
        }
        Duration between = Duration.between(order.getSuitStartTime(), endTime);

        SuitTimeUnit unit = SuitTimeUnit.getByValue(order.getSuitTimeUnit());
        ServiceUtil.assertion(unit == null, "订单套餐单位无效");

        // 计算总使用的周期数，不满足一个周期也算一个周期
        long totalSeconds = between.getSeconds(); // 总使用时长
        long secondSuitTime = order.getSuitSeconds();
        long totalRound = totalSeconds / secondSuitTime + (totalSeconds % secondSuitTime != 0 ? 1 : 0);
        if (totalRound <= 0) {
            totalRound = 1;
        }

        // 使用金额 = 使用周期数 * 单价
        return BigDecimal.valueOf(totalRound).multiply(order.getSuitPrice());
    }

    // 计算分时段计量金额
    private BigDecimal calcTimingCountAmount(TransactionBillVO order) {
        return calcTimingCountAmount(order.getBillId());
    }

    @Override
    public BigDecimal calcTimingCountAmount(Long billId) {
        if (billId == null) {
            return null;
        }
        BillEleRecordQuery query = new BillEleRecordQuery();
        query.setBillId(billId);
        BigDecimal amount = billEleRecordService.selectSumOfTotalPrice(query);
        if (amount == null) {
            return BigDecimal.ZERO;
        }
        return amount;
    }

    // 计算分时段计时金额
    private BigDecimal calcTimingTimeAmount(TransactionBillVO order, LocalDateTime endTime) {
        // 订单不存在 或者 开始时间为空，则表示未开始使用，返回0
        if (order == null || order.getSuitStartTime() == null) {
            return BigDecimal.ZERO;
        }
        LocalDateTime startTime = order.getSuitStartTime();
        List<BigDecimal> suitGearAmount = order.getSuitGearAmount();
        List<Integer> suitGearTime = order.getSuitGearTime();

        // 总金额
        BigDecimal total = BigDecimal.ZERO;

        // 初始时间
        LocalDateTime i = startTime.withMinute(0).withSecond(0);

        // 累加1小时
        while (i.isBefore(endTime)) {
            LocalDateTime plusI = i.plusHours(1);

            // 当前每分钟平均金额
            BigDecimal minuteAmount = suitGearAmount.get(suitGearTime.get(i.getHour())).divide(BigDecimal.valueOf(60),
                    2, RoundingMode.HALF_UP);

            // 计算时间段的金额
            LocalDateTime timeA = i.isAfter(startTime) ? i : startTime;
            LocalDateTime timeB = plusI.isBefore(endTime) ? plusI : endTime;
            Duration between = Duration.between(timeA, timeB);
            total = total.add(minuteAmount.multiply(BigDecimal.valueOf(between.toMinutes())));

            i = plusI;
        }

        return total;
    }

    /**
     * 记录下操作后的余额
     *
     * @param billId  订单id
     * @param balance 余额
     */
    private void updateAfterBalance(Long billId, BigDecimal balance) {
        TransactionBill data = new TransactionBill();
        data.setBillId(billId);
        data.setAfterBalance(balance);
        transactionBillMapper.updateSmTransactionBill(data);
    }

    /**
     * 取消充值订单
     *
     * @param billNo 订单编号
     * @param status 取消后的状态
     */
    @Override
    public int cancelRecharge(String billNo, TransactionBillStatus status) {
        TransactionBillVO bill = this.selectSmTransactionBillByBillNo(billNo);
        return this.cancelRecharge(bill, status);
    }

    @Override
    public int cancelRecharge(TransactionBillVO old, TransactionBillStatus status) {

        ServiceUtil.assertion(!TransactionBillStatus.isCancel(status.getStatus()), "参数错误：状态并非取消状态");

        // 刷新支付结果
        this.refreshPayResult(old);

        // 查询数据
        TransactionBill bill = transactionBillMapper.selectSmTransactionBillByBillId(old.getBillId());
        ServiceUtil.assertion(bill == null || bill.getBillId() == null, "订单不存在");
        ServiceUtil.assertion(!TransactionBillType.RECHARGE.getType().equals(bill.getType()), "非充值订单，不允许取消");

        // 允许取消的状态
        List<String> allowCancel = Arrays.asList(
                TransactionBillStatus.UNPAID.getStatus(),
                TransactionBillStatus.UNPAID_DEPOSIT.getStatus());
        ServiceUtil.assertion(!allowCancel.contains(bill.getStatus()), "当前订单状态不允许取消");

        Integer result = transactionTemplate.execute(s -> {
            // 执行取消订单
            TransactionBill data = new TransactionBill();
            data.setStatus(status.getStatus());
            TransactionBillQuery query = new TransactionBillQuery();
            query.setBillId(bill.getBillId());
            query.setStatusList(allowCancel);
            query.setType(TransactionBillType.RECHARGE.getType());
            int cancel = this.updateByQuery(data, query);
            ServiceUtil.assertion(cancel != 1, "取消订单失败：状态已发生变化");

            // 恢复会员次数
            if (bill.getVipId() != null) {
                vipService.unUseVip(bill.getVipId());
            }

            // 取消支付订单
            boolean cancelPay = false;
            if (TransactionBillStatus.UNPAID.getStatus().equals(bill.getStatus())) {
                cancelPay = payBillService.closeByBstId(bill.getBillId(), PayBillBstType.RECHARGE_ORDER.getType());
            } else if (TransactionBillStatus.UNPAID_DEPOSIT.getStatus().equals(bill.getStatus())) {
                cancelPay = payBillService.closeByBstId(bill.getBillId(),
                        PayBillBstType.RECHARGE_ORDER_DEPOSIT.getType());
            }
            ServiceUtil.assertion(!cancelPay, "取消支付订单失败");

            return cancel;
        });

        return result == null ? 0 : result;
    }

    @Override
    public TransactionBillVO selectSmTransactionBillByBillNo(String billNo) {
        return transactionBillMapper.selectSmTransactionBillByBillNo(billNo);
    }

    @Override
    public List<TransactionBillVO> selectNoPayedRecharge() {
        TransactionBillQuery dto = new TransactionBillQuery();
        dto.setStatusList(Arrays.asList(TransactionBillStatus.UNPAID.getStatus(),
                TransactionBillStatus.PAYING.getStatus(), TransactionBillStatus.UNPAID_DEPOSIT.getStatus()));
        dto.setType(TransactionBillType.RECHARGE.getType());
        return this.selectSmTransactionBillList(dto);
    }

    /**
     * 查询设备充值失败列表
     *
     * @param userId
     * @return
     */
    @Override
    public List<TransactionBillVO> selectDeviceRechargeFailList(Long userId) {
        if (userId == null) {
            return Collections.emptyList();
        }
        // 查询充值失败列表
        TransactionBillQuery dto = new TransactionBillQuery();
        dto.setUserId(userId);
        dto.setStatus(TransactionBillStatus.SUCCESS.getStatus());
        dto.setDeviceRechargeStatus(TransactionBillDeviceRechargeStatus.FAIL.getStatus());
        dto.setType(TransactionBillType.RECHARGE.getType());
        dto.setIsFinished(false);
        List<TransactionBillVO> list = this.selectSmTransactionBillList(dto);

        if (!CollectionUtils.isEmptyElement(list)) {
            // 修改状态为蓝牙充值
            transactionBillMapper.updateDeviceRechargeStatusByIds(
                    list.stream().map(TransactionBillVO::getBillId).collect(Collectors.toList()),
                    TransactionBillDeviceRechargeStatus.BLUETOOTH.getStatus());
        }

        // 查询蓝牙充值列表
        dto.setDeviceRechargeStatus(TransactionBillDeviceRechargeStatus.BLUETOOTH.getStatus());
        return selectSmTransactionBillList(dto);
    }

    /**
     * 查询支付结果，直到过期
     *
     * @param bill     订单
     * @param delay    延迟时间
     * @param timeUnit 时间单位
     */
    @Override
    public void refreshPayResultBeforeExpire(TransactionBillVO bill, int delay, TimeUnit timeUnit) {

        // 刷新支付结果
        refreshPayResult(bill);

        // 获取刷新后的订单
        TransactionBillVO newBill = transactionBillMapper.selectSmTransactionBillByBillId(bill.getBillId());
        if (newBill == null) {
            log.error("获取订单{}为空", bill.getBillId());
            return;
        }

        // 未支付成功
        List<String> successList = TransactionBillStatus.asList(TransactionBillStatus.SUCCESS,
                TransactionBillStatus.SUCCESS_DEPOSIT);
        if (!successList.contains(newBill.getStatus())) {
            if (newBill.getExpireTime() != null && new Date().compareTo(newBill.getExpireTime()) < 0) {
                // 未过期，继续延迟查询
                log.info("{}支付失败，未过期，继续延迟刷新", newBill);
                scheduledExecutorService.schedule(() -> {
                    this.refreshPayResultBeforeExpire(newBill, delay, timeUnit);
                }, delay, timeUnit);
            } else {
                log.info("{}支付失败，过期取消订单", newBill);
                this.cancelRecharge(newBill.getBillNo(), TransactionBillStatus.SYS_CANCELED);
            }
        }
    }

    /**
     * 查询数量并映射
     *
     * @param query     查询条件
     * @param keyMapper 映射方法
     */
    @Override
    public <K> Map<K, BillCountVo> selectCountMap(TransactionBillQuery query,
            Function<? super BillCountVo, ? extends K> keyMapper) {
        List<BillCountVo> list = this.selectCount(query);
        if (CollectionUtils.isEmptyElement(list)) {
            return Collections.emptyMap();
        }
        return list.stream().collect(Collectors.toMap(keyMapper, item -> item));
    }

    /**
     * 蓝牙充值成功
     *
     * @param billNo
     * @return
     */
    @Override
    public boolean bluetoothRechargeSuccess(String billNo) {
        TransactionBillVO bill = selectSmTransactionBillByBillNo(billNo);
        ServiceUtil.assertion(bill == null, "订单不存在", 10001);

        // 更新设备充值状态
        TransactionBill data = new TransactionBill();
        data.setDeviceRechargeStatus(TransactionBillDeviceRechargeStatus.SUCCESS.getStatus());
        data.setOpenMsg("蓝牙充值成功");
        data.setBillId(bill.getBillId());

        return this.updateSmTransactionBill(data) == 1;
    }

    @Override
    public int refund(BillRefundDTO dto) {
        // 校验订单
        TransactionBillVO bill = this.selectSmTransactionBillByBillId(dto.getBillId());
        ServiceUtil.assertion(bill == null, "ID为%s的订单不存在", dto.getBillId());
        ServiceUtil.assertion(dto.getRefundAmount().compareTo(bill.getMoney()) > 0, "订单编号为%s的订单退款金额不允许大于订单金额",
                bill.getBillNo());
        ServiceUtil.assertion(!TransactionBillStatus.canRefund().contains(bill.getStatus()), "订单编号为%s的订单状态不允许退款",
                bill.getBillNo());

        // 是否判断订单已完成
        if (dto.getCheckFinish() != null && dto.getCheckFinish()) {
            ServiceUtil.assertion(bill.getIsFinished() == null || !bill.getIsFinished(), "订单编号为%s的订单未完成，不允许退款",
                    bill.getBillNo());
        }

        // 拼接分成列表
        transactionAssembler.assembleBonusList(bill);
        List<BonusVO> bonusList = bill.getBonusList();
        ServiceUtil.assertion(CollectionUtils.isEmptyElement(bonusList), "订单编号为%s的订单没有收益信息，无法退款", bill.getBillNo());

        Integer result = transactionTemplate.execute(status -> {
            // 分成方按照比例扣减余额
            BigDecimal refundAmount = dto.getRefundAmount(); // 总退款金额
            int updateRefundBonus = this.updateRefundBonus(bonusList, refundAmount, bill.getMoney());
            ServiceUtil.assertion(updateRefundBonus == 0 || updateRefundBonus > bonusList.size(), "商户余额更新失败");

            // 发起退款
            PayBillRefundDTO refundDto = new PayBillRefundDTO();
            refundDto.setPayId(bill.getPayId());
            refundDto.setRefundAmount(dto.getRefundAmount());
            refundDto.setRefundReason(dto.getRefundReason());
            int refund = payBillService.refund(refundDto);
            ServiceUtil.assertion(refund != 1, "退款失败");

            return refund;
        });

        return result == null ? 0 : result;
    }

    /**
     * 更新分成的退款金额
     *
     * @param bonusList    分成列表
     * @param refundAmount 本次退款金额
     * @param billAmount   订单总金额
     */
    private int updateRefundBonus(List<BonusVO> bonusList, BigDecimal refundAmount, BigDecimal billAmount) {
        if (CollectionUtils.isEmptyElement(bonusList)) {
            return 0;
        }

        // 构建退款列表
        List<Bonus> refundList = new ArrayList<>();
        BigDecimal dividedAmount = BigDecimal.ZERO; // 已分配金额

        for (BonusVO bonus : bonusList) {
            if (bonus == null) {
                continue;
            }

            // 计算该分成记录的可退金额 = 分配金额 - 已退金额
            BigDecimal availableRefund = bonus.getAmount()
                    .subtract(bonus.getRefundAmount() == null ? BigDecimal.ZERO : bonus.getRefundAmount());
            if (availableRefund.compareTo(BigDecimal.ZERO) <= 0) {
                continue; // 跳过已无可退金额的记录
            }

            // 按原始比例计算本次应退金额 = 本次退款总额 * (原始分配金额/订单总额)
            BigDecimal proportion = bonus.getAmount().divide(billAmount, 6, RoundingMode.HALF_UP);
            BigDecimal shouldRefund = refundAmount.multiply(proportion).setScale(2, RoundingMode.HALF_UP);

            // 实际退款金额取可退金额与应退金额的较小值
            BigDecimal actualRefund = shouldRefund.min(availableRefund);

            Bonus refundBonus = new Bonus();
            refundBonus.setId(bonus.getId());
            refundBonus.setStatus(bonus.getStatus());
            refundBonus.setRefundAmount(actualRefund);
            refundBonus.setArrivalId(bonus.getArrivalId());
            refundBonus.setArrivalType(bonus.getArrivalType());
            refundBonus.setBillNo(bonus.getBillNo());
            refundBonus.setBillId(bonus.getBillId());
            refundBonus.setToBalance(bonus.getToBalance());
            refundList.add(refundBonus);

            dividedAmount = dividedAmount.add(actualRefund);
        }

        // 处理误差
        BonusUtil.handleRefundAmountDiff(refundList, bonusList, dividedAmount, refundAmount);

        // 校验金额
        for (Bonus bonus : refundList) {
            ServiceUtil.assertion(bonus.getRefundAmount().compareTo(BigDecimal.ZERO) < 0, "退款金额不允许小于0");
        }
        BigDecimal sum = CollectionUtils.sumDecimal(refundList, Bonus::getRefundAmount);
        ServiceUtil.assertion(sum.compareTo(refundAmount) != 0, "退款金额分配出错");

        // 执行退款逻辑
        return executeRefund(refundList);
    }

    // 执行分成退款
    private int executeRefund(List<Bonus> refundList) {
        Integer result = transactionTemplate.execute(status -> {
            int update = 0;

            // 余额退款
            for (Bonus bonus : refundList) {
                if (BonusStatus.WAIT_DIVIDE.getStatus().equals(bonus.getStatus())) {
                    int refund = bonusService.refundWhenWaitDivide(bonus.getId(), bonus.getRefundAmount());
                    ServiceUtil.assertion(refund != 1, "可退款金额不足");
                } else if (BonusStatus.DIVIDEND.getStatus().equals(bonus.getStatus())) {
                    int refund = bonusService.refundWhenDividend(bonus.getId(), bonus.getRefundAmount());
                    ServiceUtil.assertion(refund != 1, "可退款金额不足");

                    if (bonus.getToBalance() != null && bonus.getToBalance()) {
                        if (BonusArrivalType.userList().contains(bonus.getArrivalType())) {
                            userService.subtractBalance(
                                    bonus.getArrivalId(),
                                    bonus.getRefundAmount(),
                                    String.format("订单退款:%s", bonus.getBillNo()),
                                    RecordBalanceBstType.RECHARGE,
                                    bonus.getBillId());
                        } else if (BonusArrivalType.deptList().contains(bonus.getArrivalType())) {
                            // deptService相关逻辑暂时不处理
                        }
                    }
                }
                update++;
            }

            // 创建分成退款记录
            List<BonusRefund> bonusRefundList = bonusRefundConverter.toPo(refundList);
            int insertBonusRefund = bonusRefundService.batchInsert(bonusRefundList);
            ServiceUtil.assertion(insertBonusRefund != bonusRefundList.size(), "创建分成退款记录失败");

            return update;
        });

        return result == null ? 0 : result;
    }

    @Override
    public int updateByQuery(TransactionBill data, TransactionBillQuery query) {
        if (query == null) {
            return 0;
        }
        return transactionBillMapper.updateByQuery(data, query);
    }

    @Override
    public int refreshPayResult(String billNo) {
        return this.refreshPayResult(this.selectSmTransactionBillByBillNo(billNo));
    }

    @Override
    public int refreshPayResult(List<TransactionBillVO> billList) {
        if (CollectionUtils.isEmptyElement(billList)) {
            return 0;
        }

        // 获取支付订单列表
        PayBillQuery query = new PayBillQuery();
        query.setBstIds(CollectionUtils.map(billList, TransactionBillVO::getBillId));
        query.setBstTypes(PayBillBstType.asList(PayBillBstType.RECHARGE_ORDER, PayBillBstType.RECHARGE_ORDER_DEPOSIT));
        List<PayBillVO> payList = payBillService.selectPayBillList(query);

        // 刷新支付订单结果
        return payBillService.refreshPayResult(payList);
    }

    @Override
    public int addRefundAmount(Long billId, BigDecimal refundAmount) {
        if (billId == null) {
            return 0;
        }
        return transactionBillMapper.addRefundAmount(billId, refundAmount);
    }

    @Override
    public List<TransactionBillVO> selectUsingBill(Long userId) {
        TransactionBillQuery query = new TransactionBillQuery();
        query.setUserId(userId);
        return this.selectUsingBill(query);
    }

    @Override
    public List<TransactionBillVO> selectUsingBill(TransactionBillQuery query) {
        query.setIsUsing(true);
        query.setType(TransactionBillType.RECHARGE.getType());
        return this.selectSmTransactionBillList(query);
    }

    @Override
    public int batchCloseBillByDevice(List<TransactionBillVO> billList, DeviceVO device, BigDecimal totalEle) {
        if (CollectionUtils.isEmptyElement(billList)) {
            return 0;
        }
        EndUseBO bo = new EndUseBO();
        bo.setDevice(device);
        bo.setTotalEle(totalEle);

        if (CollectionUtils.isNotEmptyElement(billList)) {
            // 关闭订单
            int sum = 0;
            for (TransactionBillVO bill : billList) {
                Integer result = transactionTemplate.execute(status -> {
                    bo.setOrder(bill);
                    int end = this.endUse(bo);
                    ServiceUtil.assertion(end != 1, "关闭订单失败:" + bill.getBillNo());
                    return end;
                });
                sum += (result == null ? 0 : result);
            }
            return sum;
        }

        return 0;
    }

    @Override
    public <T> List<TransactionAmountVO<T>> selectCommonSumOfMoney(TransactionBillQuery query, String groupBy) {
        return transactionBillMapper.selectCommonSumOfMoney(query, groupBy);
    }

    @Override
    public TransactionBillVO selectOne(TransactionBillQuery query) {
        PageHelper.startPage(1, 1);
        List<TransactionBillVO> list = this.selectSmTransactionBillList(query);
        if (CollectionUtils.isEmptyElement(list)) {
            return null;
        }
        return list.get(0);
    }

    @Override
    public int switchDevice(TransactionBillVO bill, boolean open) {
        ServiceUtil.assertion(bill == null, "订单不存在");
        ServiceUtil.assertion(bill.getIsUsing() == null || !bill.getIsUsing(), "该订单不是正在使用中的订单，无法操作");

        DeviceVO device = deviceService.selectById(bill.getDeviceId());
        ServiceUtil.assertion(device == null, "设备不存在");
        ServiceUtil.assertion(StringUtils.isAllBlank(device.getMac(), device.getMac2()), "设备MAC为空，请联系管理员处理");
        deviceService.pullDeviceInfo(device, null);

        // 开启
        if (open) {
            // 分时段订单，直接open
            if (SuitFeeType.timingList().contains(bill.getSuitFeeType())) {
                return deviceService.switchDevice(device, DevicePowerStatus.ON, "分时段订单" + bill.getBillNo() + "临时开启");
            }
            // 其余订单，同步时长
            else {
                CommandResponse res = deviceService.syncTime(device.getDeviceId(), LocalDateTime.now(),
                        "时长订单" + bill.getBillNo() + "临时开启");
                return res != null && res.isSuccess() ? 1 : 0;
            }
        } else {
            return deviceService.switchDevice(device, DevicePowerStatus.OFF, "订单" + bill.getBillNo() + "临时关闭");
        }
    }

    @Override
    public TransactionBillVO selectLastOne(TransactionBillQuery query) {
        PageHelper.orderBy("stb.bill_id desc");
        return selectOne(query);
    }

    @Override
    public UserWithdrawServiceVO getUserWithdrawService(Long userId, Long channelId) {
        SmUserVO user = userService.selectSmUserByUserId(userId);
        ChannelWithdrawVO channel = channelWithdrawService.selectChannelWithdrawByChannelId(channelId);
        return this.getUserWithdrawService(user, channel);
    }

    @Override
    public DoPayVO pay(RechargePayBO bo) {
        // 校验
        ServiceUtil.assertion(transactionBillValidator.prePay(bo));

        TransactionBillVO order = bo.getOrder();

        Long lockKey = order.getBillId();
        ServiceUtil.assertion(!redisLock.lock(RedisLockKey.PREPAY, lockKey), "当前订单正在支付，请稍后重试");
        try {
            return transactionTemplate.execute(status -> {
                // 修改订单信息
                TransactionBill data = new TransactionBill();
                data.setServiceCharge(order.getServiceCharge());
                data.setArrivalAmount(order.getArrivalAmount());
                TransactionBillQuery query = new TransactionBillQuery();
                query.setStatus(TransactionBillStatus.UNPAID.getStatus());
                query.setBillId(order.getBillId());
                int paying = this.updateByQuery(data, query);
                ServiceUtil.assertion(paying != 1, "订单状态已发生变化，更新失败");

                // 创建支付订单并发起支付
                return payBillService.createPayBill(payBillConverter.toPoByRechargeMoney(bo));
            });
        } finally {
            redisLock.unlock(RedisLockKey.PREPAY, lockKey);
        }
    }

    @Override
    public List<TransactionBillVO> selectWithdrawList(TransactionBillQuery query) {
        query.setType(TransactionBillType.WITHDRAW.getType());
        return transactionBillMapper.selectWithdrawList(query);
    }

    @Override
    public TransactionBillVO selectWithdrawById(Long billId) {
        return transactionBillMapper.selectWithdrawById(billId);
    }

    @Override
    public int selectSimpleCount(TransactionBillQuery query) {
        return transactionBillMapper.selectSimpleCount(query);
    }

    /**
     * 转账成功后
     */
    @Override
    public int onTransferSuccess(TransferVO transfer) {
        if (transfer == null || transfer.getBstId() == null) {
            return 0;
        }

        Integer result = transactionTemplate.execute(status -> {
            // 修改提现状态
            TransactionBill data = new TransactionBill();
            data.setStatus(TransactionBillStatus.WITHDRAW_SUCCESS.getStatus());
            data.setPayTime(transfer.getUpdateTime());
            TransactionBillQuery query = new TransactionBillQuery();
            query.setStatus(TransactionBillStatus.WITHDRAW_PAYING.getStatus());
            query.setBillId(transfer.getBstId());
            int update = this.updateByQuery(data, query);
            ServiceUtil.assertion(update != 1, "修改提现状态失败，提现状态已发生改变");
            return update;
        });

        return result == null ? 0 : result;
    }

    /**
     * 转账失败后
     */
    @Override
    public int onTransferFail(TransferVO transfer) {
        if (transfer == null || transfer.getBstId() == null) {
            return 0;
        }

        TransactionBillVO withdraw = this.selectWithdrawById(transfer.getBstId());
        if (withdraw == null) {
            return 0;
        }

        Integer result = transactionTemplate.execute(status -> {
            // 修改提现状态
            TransactionBill data = new TransactionBill();
            data.setStatus(TransactionBillStatus.WITHDRAW_FAIL.getStatus());
            TransactionBillQuery query = new TransactionBillQuery();
            query.setStatus(TransactionBillStatus.WITHDRAW_PAYING.getStatus());
            query.setBillId(transfer.getBstId());
            int update = this.updateByQuery(data, query);
            ServiceUtil.assertion(update != 1, "修改提现状态失败，提现状态已发生改变");

            // 将提现金额退回用户
            userService.addBalance(withdraw.getUserId(), withdraw.getMoney(),
                    String.format("提现%s打款失败", withdraw.getBillNo()), RecordBalanceBstType.WITHDRAW,
                    transfer.getBstId());

            return update;
        });

        return result == null ? 0 : result;
    }

    @Override
    public PrepayPriceVO calcRechargePrePayPrice(Long vipId, Long suitId) {
        // 获取套餐
        SuitVO suit = suitService.selectSuitBySuitId(suitId);
        // 获取会员
        VipVO vip = vipService.selectVipById(vipId);
        return RechargeUtils.calcRechargePrePayPrice(vip, suit);
    }

    @Override
    public BigDecimal selectSumOfServiceCharge(TransactionBillQuery query) {
        return transactionBillMapper.selectSumOfServiceCharge(query);
    }

    @Override
    public List<LongDecimalVO> selectSumOfMoneyGroupByStoreId(TransactionBillQuery query) {
        return transactionBillMapper.selectSumOfMoneyGroupByStoreId(query);
    }

    @Override
    public List<LongIntegerVO> selectCountGroupByStoreId(TransactionBillQuery query) {
        return transactionBillMapper.selectCountGroupByStoreId(query);
    }

    @Override
    public List<LocalDateDecimalVO> selectDailyMoney(TransactionBillQuery query) {
        return transactionBillMapper.selectDailyMoney(query);
    }

    @Override
    public List<LocalDateTimeIntegerVO> selectDailyCount(TransactionBillQuery query) {
        return transactionBillMapper.selectDailyCount(query);
    }

    @Override
    public boolean handleFinishedBonus(TransactionBillVO bill) {
        if (bill == null) {
            return false;
        }
        if (bill.getFinished()) {
            return true;
        }

        Boolean result = transactionTemplate.execute(status -> {
            // 更新订单流程状态
            // 若订单没有结束时间，则更新订单的结束时间
            TransactionBill data = new TransactionBill();
            data.setFinished(true);
            if (bill.getSuitEndTime() == null) {
                data.setSuitEndTime(LocalDateTime.now());
            }
            TransactionBillQuery query = new TransactionBillQuery();
            query.setType(TransactionBillType.RECHARGE.getType());
            query.setIsFinished(true);
            query.setFinished(false);
            query.setStatusList(TransactionBillStatus.payedOrder());
            query.setBillId(bill.getBillId());
            int rows = this.updateByQuery(data, query);
            ServiceUtil.assertion(rows != 1, "订单%s的流程状态已发生变化，请稍后重试", bill.getBillNo());

            if (bill.getBonusList() != null) {
                // 过滤没有预计支付时间的待分成
                List<BonusVO> waitDivideBonusList = bill.getBonusList().stream()
                        .filter(item -> BonusStatus.WAIT_DIVIDE.getStatus().equals(item.getStatus()) && item.getPrePayTime() == null)
                        .collect(Collectors.toList());
                if (CollectionUtils.isNotEmptyElement(waitDivideBonusList)) {
                    // 预支付
                    bonusService.prePay(bill.getBonusList());
                }
            }

            return true;
        });

        return result != null && result;
    }
}
