package com.ruoyi.ss.user.domain.dto;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Pattern;
import javax.validation.constraints.Size;

import com.ruoyi.common.utils.RegexpUtils;

import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

/**
 * @author wjh
 * 2024/8/26
 */
@Data
public class UserRealNameDTO {

    @ApiModelProperty("用户ID")
    private Long userId;

    @ApiModelProperty("实名认证类型")
    private String type;

    @ApiModelProperty("姓名")
    @NotBlank(message = "姓名不允许为空")
    @Size(max = 20, message = "姓名长度不能超过20")
    private String realName;

    @ApiModelProperty("身份证")
    @NotBlank(message = "身份证不允许为空")
    @Size(max = 18, message = "身份证长度不能超过18")
    @Pattern(regexp = RegexpUtils.IDENTITY_CARD_REGEXP, message = "身份证号格式错误")
    private String realIdCard;

    @ApiModelProperty("手机号")
    @Pattern(regexp = RegexpUtils.MOBILE_PHONE_REGEXP, message = "手机号格式错误")
    private String realPhone;

    @ApiModelProperty("身份证正面")
    @NotBlank(message = "身份证正面不允许为空")
    private String idCardFront;

    @ApiModelProperty("身份证背面")
    @NotBlank(message = "身份证背面不允许为空")
    private String idCardBack;

    @ApiModelProperty("风控信息ID")
    private Long riskInfoId;

}
