package com.ruoyi.ss.vipLevel.domain.enums;

import java.util.List;

import com.ruoyi.common.utils.collection.CollectionUtils;

import lombok.AllArgsConstructor;
import lombok.Getter;

/**
 * @author wjh
 * 2025/1/18
 */
@Getter
@AllArgsConstructor
public enum VipLevelLimitType {

    NONE("1", "不限制"),
    WEEK("2", "自然周"),
    DAYS_30("3", "30天");

    private final String type;
    private final String msg;

    /**
     * 需要重置周期计数的VIP等级
     */
    public static List<String> needReset() {
        return CollectionUtils.map(VipLevelLimitType::getType, WEEK, DAYS_30);
    }

}
