package com.ruoyi.web.controller.app;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.ss.billEleRecord.domain.BillEleRecordQuery;
import com.ruoyi.ss.billEleRecord.service.BillEleRecordService;
import com.ruoyi.ss.transactionBill.domain.vo.TransactionBillVO;
import com.ruoyi.ss.transactionBill.service.TransactionBillService;
import com.ruoyi.ss.transactionBill.service.TransactionBillValidator;

import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("/app/billEleRecord")
public class AppBillEleRecordController extends BaseController{

    @Autowired
    private BillEleRecordService billEleRecordService;

    @Autowired
    private TransactionBillValidator transactionBillValidator;

    @Autowired
    private TransactionBillService transactionBillService;

    @ApiOperation("查询订单电量记录")
    @GetMapping("/listByBill")
    public AjaxResult listByBill(Long billId) {
        TransactionBillVO bill = transactionBillService.selectSmTransactionBillByBillId(billId);
        if (!transactionBillValidator.canViewOrder(bill, getUserId())) {
            return error("您无权查看ID为" + billId + "的订单信息");
        }
        BillEleRecordQuery query = new BillEleRecordQuery();
        query.setBillId(billId);
        return success(billEleRecordService.selectBillEleRecordList(query));
    }
}