package com.ruoyi.web.controller.app;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.github.pagehelper.PageHelper;
import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.ss.hardVersion.domain.HardVersionQuery;
import com.ruoyi.ss.hardVersion.domain.HardVersionVO;
import com.ruoyi.ss.hardVersion.service.HardVersionService;

import io.swagger.annotations.ApiOperation;

@RestController
@RequestMapping("/app/hardVersion")
public class AppHardVersionController extends BaseController  {

    @Autowired
    private HardVersionService hardVersionService;

    @ApiOperation("获取最新一个硬件版本")
    @GetMapping("/lastOne")
    public AjaxResult getLastOne(HardVersionQuery query) {
        PageHelper.orderBy("create_time desc");
        HardVersionVO hardVersion = hardVersionService.selectOne(query);
        return success(hardVersion);
    }
    
}