package com.ruoyi.web.controller.mch;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.ss.abnormal.domain.AbnormalQuery;
import com.ruoyi.ss.abnormal.service.AbnormalService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/mch/abnormal")
public class MchAbnormalController extends BaseController {

    @Autowired
    private AbnormalService abnormalService;

    @ApiOperation("商户处理申诉状态")
    @PutMapping
    public AjaxResult updateAbnormalStatus(AbnormalQuery query) {
        return AjaxResult.success(abnormalService.updateAbnormal(query));
    }

    @ApiOperation("商户查询用户故障反馈列表")
    @GetMapping("/list")
    public TableDataInfo abnormalList(AbnormalQuery query) {
        startPage();
        query.setStoreId(getUserId());
        return getDataTable(abnormalService.selectAbnormalList(query));
    }

    @ApiOperation("商户查询用户故障反馈详情")
    @GetMapping("/{id}")
    public AjaxResult selectAbnormal(Long id) {
        return AjaxResult.success(abnormalService.selectAbnormalByAbnormalId(id));
    }
}
