package com.ruoyi.web.controller.staff;

import com.ruoyi.common.core.controller.BaseController;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.dashboard.index.domain.dto.BusinessStatisticsQuery;
import com.ruoyi.dashboard.index.service.DashboardService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * 合伙人报表Controller
 * @author wjh
 * 2024/11/28
 */
@RestController
@RequestMapping("/staff/dashboard")
public class StaffDashboardController extends BaseController {

    @Autowired
    DashboardService dashboardService;

    @ApiOperation("合伙人获取店铺维度的订单统计")
    @GetMapping("/businessStatisticsByStore")
    public AjaxResult businessStatisticsByStore(BusinessStatisticsQuery query) {
        query.setStaffId(getUserId());
        return success(dashboardService.businessStatisticsByStore(query));
    }

    @ApiOperation("合伙人获取指定店铺的订单统计")
    @GetMapping("/businessStatisticsByDevice")
    public AjaxResult businessStatisticsByDevice(BusinessStatisticsQuery query) {
        query.setStaffId(getUserId());
        return success(dashboardService.businessStatisticsByDevice(query));
    }


}
